<?php
function loadSQL( &$base, $query="") 
{   
    global $errTxt;
    global $langTxt;
    global $infoText;
    if( $query=="" )
    {
        $typ = $base->getTypeInfo();
        $tableName = $typ["tableName"];
        $query = "SELECT * FROM $tableName";
    }
    $result=mysql_query($query);
    if( $result==0 ) 
    {
        $txt = sprintf( $errTxt[general_mysql_error], mysql_error() );
        $infoText[] = $langTxt["DBP30"].": ".$txt;
        return general_mysql_error;
    }
    $row=mysql_fetch_array($result, MYSQL_ASSOC);
    if( $row==0 ) 
    {
        return not_found_in_db;
    }
    $base->init( $row );
    return ok;
}
function loadObjectsSQL( $base, $query="",&$objArr) 
{   
    global $errTxt;
    global $langTxt;
    global $infoText;
    $objArr = array();
    $typ = $base->getTypeInfo();
    if( $query=="" ) {
        $tableName = $typ["tableName"];
        $query = "SELECT * FROM $tableName";
    }
    $result=mysql_query($query);
    if( $result==0 ) 
    {
        $txt = sprintf( $errTxt[general_mysql_error], mysql_error() );
        $infoText[] = $langTxt["DBP30"].": ".$txt;
        return general_mysql_error;
    }
    $num = mysql_num_rows($result);
    if ($num==0) {
        return not_found_in_db;
    }
    $className=get_class($base);
    for($i=0;$i<$num;$i++) {
        $row=mysql_fetch_array($result, MYSQL_ASSOC);
        $objArr[$i] = new $className;
        $ret = $objArr[$i]->init($row);
        if ($ret!=ok) 
        {
            $infoText[] = $langTxt["DBP40"];
            return $ret;
        }
    }
    return ok;
}
function load( &$base, $whereFields="", $whatFields="*" ) 
{   
    $typ = $base->getTypeInfo();
    $tableName = $typ["tableName"];
    $query = "SELECT $whatFields FROM $tableName";
    if( $whereFields=="" ) $whereFields=getPrimaryKey( $typ );
    foreach( $whereFields as $index=>$attribute )
    {
        if( !isset($base->{$attribute}) ) unset($whereFields[$index]);
    }
    if( sizeof($whereFields)==0 ) 
    {
        $whereFields = array_keys( $typ["attributes"] );
        foreach( $whereFields as $index=>$attribute )
        {
            if(!isset($base->{$attribute})) unset($whereFields[$index]);
        }
    }
    $firstField = TRUE;
    foreach( $whereFields as $key )
    {
        if( isset($base->{$key}) )
        {
            $value = $base->{$key};
            $value=addcslashes($value,"'");
            if( $firstField )
            {
                $query .= " WHERE $key='$value'";
                $firstField = FALSE;
            }
            else $query .= " AND $key='$value'";
        }
    }
    $ret = $base->loadSQL( $query );
    $noError = ($ret!=general_mysql_error);
    return $ret;
}
function create(&$base)
{
    global $errTxt;
    global $langTxt;
    global $infoText;
    global $whatHappened;
    $ret = $base->valid();
    if( $ret || $whatHappened=="invalid_form" )
    {
        return $ret;
    }
    $typ = $base->getTypeInfo();
    $tableName = $typ["tableName"];
    $query =  "INSERT INTO $tableName";
    $aia = getAutoIncrementAttribute( $typ );
    if( !$aia ) 
    {
        $primaryKey = getPrimaryKey( $typ );
        if( sizeof($primaryKey)==1 && 
            !isset($base->{$primaryKey[0]}) )
        {
            $primaryKey = $primaryKey[0];
            $className = get_class( $base );
            $object = new $className;
            mt_srand((double)microtime()*1000000);
            do
            {
                $id = (int)mt_rand();
                $object->{$primaryKey} = $id;
                $ret = load($object);
                if( $ret==general_mysql_error )
                {
                    $infoText[] = $langTxt["DBP60"];
                    return $ret;
                }
            }
            while( !$ret );
            $base->{$primaryKey} = $id;
        }
    }
    if( get_class($base)=="user" ) $base->ownerId = $base->id; 
    $s = getCreateSetStr($base, $typ);
    if( $s!="" ) $query.=" SET $s";
    $result=mysql_query($query);
    if( $result==0 ) 
    {
        $txt = sprintf( $errTxt[general_mysql_error], mysql_error() );
        if( mysql_errno()==1062 ) return allready_in_db;
        else 
        {
            $infoText[] = $langTxt["DBP70"].": ".$txt;
            return general_mysql_error;
        }    
    }
    if( $aia )  $base->{$aia} = mysql_insert_id();
    return ok;        
}
function getCreateSetStr($base, $typ , $create=TRUE)
{
    $object_vars = get_object_vars($base);
    $firstField = TRUE;
    $query = "";
    foreach( $object_vars as $attribute=>$value )
    {
        if( !in_array("no column", $typ["attributes"][$attribute]) && 
            ($attribute!="creationtime" || !$create) && 
            $attribute!="modificationtime")
        {
            if( !$firstField ) $query .= ", ";
            $value=addcslashes($value,"'");
            $query .= "$attribute='$value'";
            $firstField = FALSE;
        }
    }
    $typ = $base->getTypeInfo();
    if (isset($typ["attributes"]["creationtime"])&&$create)
    {
        if( !$firstField ) $query .= ", ";
        $query.="creationtime='".time()."' ";
        $firstField = FALSE;
    }
    if (isset($typ["attributes"]["modificationtime"]))
    {
        if( !$firstField ) $query .= ", ";
        $query.="modificationtime='".time()."'";
        $firstField = FALSE;
    }
    return $query;
} 
function modify( $base, $whereFields="" )
{
    global $errTxt;
    global $langTxt;
    global $infoText;
    global $whatHappened;
    $ret = $base->valid();
    if( $ret || $whatHappened=="invalid_form" )
    {
        return $ret;
    }
    $typ = $base->getTypeInfo();
    $tableName = $typ["tableName"];
    $query="UPDATE $tableName SET ";
    $query .= getCreateSetStr($base, $typ, FALSE);
    if( $whereFields=="" ) $whereFields=getPrimaryKey( $typ );
    if( $whereFields )
    {
        $firstField = TRUE;
        foreach( $whereFields as $key )
        {
            if( isset($base->{$key}) )
            {
                $value = $base->{$key};
                $value=addcslashes($value,"'");
                if( $firstField )
                {
                    $query .= " WHERE $key='$value'";
                    $firstField = FALSE;
                }
                else $query .= " AND $key='$value'";
            }
        }
    }
    /*
    if( $tableName=="user_zorum" && isset($base->id) && 
        isset($base->name) && $base->id==$base->name )
    {
        $userCheck = new User;
        $userCleck->id = $base->id;
        $ret = load($userCheck);
        if( $userCheck->name!=$base->name )
        {
            $s="Time: ".time()."\n\n";
            global $langTxt;
            global $zorumuser;
            global $zorumauthlevel;
            global $zorumrecognised;
            $s.= "UserName: $zorumuser->name\n";
            $s.= "UserId: $zorumuser->id\n";
            $s.= "Level of authentication: ";
            switch( $zorumauthlevel )
            {
                case Loginlib_NewUser:
                    $s.= "NewUser";
                    break;
                case Loginlib_GuestLevel:
                    $s.= "GuestLevel";
                    break;
                case Loginlib_BasicLevel:
                    $s.= "BasicLevel";
                    break;
                case Loginlib_LowLevel:
                    $s.= "LowLevel";
                    break;
                case Loginlib_HighLevel:
                    $s.= "HighLevel";
                    break;
                case Loginlib_RemoteHighLevel:
                    $s.= "RemoteHighLevel";
                    break;
            }
            $s.= "\n";
            $s.="---------------------------\n";
            global $PHP_AUTH_USER;
            global $REMOTE_USER;
            global $REMOTE_PASSWORD;
            global $Loginlib_SessionUserId;
            global $Loginlib_GlobalUserId;
            global $Loginlib_Password;
            global $Loginlib_ServerName;
            global $Loginlib_DirectoryName;
            $s.= isset($Loginlib_GlobalUserId) ? "Loginlib_GlobalUserId: $Loginlib_GlobalUserId\n" : "Loginlib_GlobalUserId is not set\n";
            $s.= isset($Loginlib_SessionUserId) ? "Loginlib_SessionUserId: $Loginlib_SessionUserId\n" : "Loginlib_SessionUserId is not set\n";
            $s.= isset($Loginlib_Password) ? "Loginlib_Password: $Loginlib_Password\n" : "Loginlib_Password is not set\n";
            $s.= isset($Loginlib_ServerName) ? "Loginlib_ServerName: $Loginlib_ServerName\n" : "Loginlib_ServerName is not set\n";
            $s.= isset($Loginlib_DirectoryName) ? "Loginlib_DirectoryName: $Loginlib_DirectoryName\n" : "Loginlib_DirectoryName is not set\n";
            $s.="\n";
            global $HTTP_GET_VARS, $HTTP_POST_VARS;
            $get_vars = "";
            $post_vars = "";
            foreach( $HTTP_GET_VARS as $get_key=>$get_var )
            {
                $get_vars .= "$get_key: $get_var, ";
            }
            foreach( $HTTP_POST_VARS as $post_key=>$post_var )
            {
                $post_vars .= "$post_key: $post_var, ";
            }
            $s.="HTTP_GET_VARS: $get_vars \n\nHTTP_POST_VARS: $post_vars\n\n";  
            mail("zorum@zorum.com", "Szuperszopacs", $s);        
            return ok;
        }
    }
    */
    $result=mysql_query($query);
    if( $result==0 ) 
    {
        $txt = sprintf( $errTxt[general_mysql_error], mysql_error() );
        $infoText[] = $langTxt["DBP90"].": ".$txt;
        if( mysql_errno()==1062 ) return allready_in_db;
        else return general_mysql_error;
    }
    return ok;
}
function delete( $base, $whereFields="" )
{
    global $errTxt;
    global $langTxt;
    global $infoText;
    if (isset($base->up)) {
        if (!isset($base->id)) {
            $ret = $base->load($whereFields);
            if ($ret==not_found_in_db) {
                return $ret;
            }
            if ($ret!=ok) {
                $infoText[] = $langTxt["DBP100"];
                return $ret;
            }
        }
        $ret=getChildrenFromDb($base,$children);
        if ($ret!=ok && $ret!=not_found_in_db) 
        {        
            $infoText[] = $langTxt["DBP110"];
            return $ret;
        }
        if ($ret==ok) {
            foreach($children as $child) {
                $ret=$child->delete($whereFields);
                if ($ret!=ok) {
                    $infoText[] = $langTxt["DBP120"];
                    return $ret;
                }
            }
        }
    }
    $typ = $base->getTypeInfo();
    $tableName = $typ["tableName"];
    $query="DELETE FROM $tableName";
    if( $whereFields=="" ) $whereFields=getPrimaryKey( $typ );
    if( $whereFields )
    {
        $firstField = TRUE;
        foreach( $whereFields as $key )
        {
            if( isset($base->{$key}) )
            {
                $value = $base->{$key};
                $value=addcslashes($value,"'");
                if( $firstField )
                {
                    $query .= " WHERE $key='$value'";
                    $firstField = FALSE;
                }
                else $query .= " AND $key='$value'";
            }
        }
    }
    $result=mysql_query($query);
    if( $result==0 ) 
    {
        $txt = sprintf( $errTxt[general_mysql_error], mysql_error() );
        $infoText[] = $langTxt["DBP130"].": ".$txt;
        return general_mysql_error;
    }
    return ok;
} 
function getPrimaryKey( $typ )
{
    if( isset($typ["primary_key"]) )
    {
        $primaryKey = &$typ["primary_key"];
        if( is_array($primaryKey) )
        {
            return $primaryKey;
        }
        else
        {
            return array($primaryKey);
        }
    }
    return 0;
}
function getAutoIncrementAttribute( $typ )
{
    foreach( $typ["attributes"] as $attribute=>$attrInfo )
    {
        if( in_array("auto increment", $attrInfo))
        {
            return $attribute;
        }
    }
    return 0;
}
function connectDb($host="",$user="",$pw="",$db="")
{
    global $zorumDbName,$zorumPw,$zorumHost,$zorumDbUser;
    global $langTxt;
    global $infoText;
    if ($host=="") $host=$zorumHost;
    if ($user=="") $user=$zorumDbUser;
    if ($pw=="") $pw=$zorumPw;
    if ($db=="") $db=$zorumDbName;
    $ret = mysql_connect($host, $user, $pw);
    if (!$ret) {
        $txt=sprintf($langTxt["DBP140"], $host, $user);
        $infoText[] = $txt;
        return cannot_connect_to_server;
    }
    $ret=mysql_select_db($db);
    if (!$ret) {
        $txt=sprintf($langTxt["DBP150"], $db);
        $infoText[] = $txt;
        return select_db_failed;
    }
    return ok;
}
function getDbCount( &$count, $query)
{
    global $errTxt;
    global $langTxt;
    global $infoText;
    $result=mysql_query($query);
    if( $result==0 ) 
    {
        $txt = sprintf( $errTxt[general_mysql_error], mysql_error() );
        $infoText[] = $langTxt["DBP160"].": ".$txt;
        return general_mysql_error;
    }
    $row=mysql_fetch_row($result);
    $count=$row[0];
    return ok;
}
function lock($tables)
{
    global $errTxt;
    global $langTxt;
    global $infoText;
    $query="LOCK TABLES ";
    if (is_string($tables)) $query.=$tables." WRITE";
    else {
        $notfirst=FALSE;
        foreach($tables as $table) {
           if ($notfirst) $query.=",";
           $query.=$table." WRITE";
           $notfirst=TRUE;
        }
    }
    $result=mysql_query($query);
    if( $result==0 ) {
        $txt = sprintf( $errTxt[general_mysql_error], mysql_error() );
        $infoText[] = $langTxt["DBP170"].": ".$txt;
        return general_mysql_error;
    }
    return ok;
}  
function unlock()
{
    global $errTxt;
    global $langTxt;
    global $infoText;
    $query="UNLOCK TABLES";
    $result=mysql_query($query);
    if( $result==0 ) {
        $txt = sprintf( $errTxt[general_mysql_error], mysql_error() );
        $infoText[] = $langTxt["DBP180"].": ".$txt;
        return general_mysql_error;
    }
    return ok;
}    
?>
