<?php
function makeSqlGetRelatives($base, $relType,$fields,&$query)
{
    global $errTxt;
    global $langTxt;
    global $infoText;
    if ($relType!="brothers" && $relType!="children") {
        $txt=$errTxt[input_param];
        $infoText[] = $langTxt["DBT10"].": ".$txt;
        return input_param;
    }
    $typ = $base->getTypeInfo();
    $tableName = $typ["tableName"];
    if ($relType=="brothers") {
        if (!isset($base->up)) {
            $txt=$errTxt[wrong_object];
            $infoText[] = $langTxt["DBT20"].": ".$txt;
            return wrong_object;
        }
        if (isset($base->upversion)) {
            $query="SELECT $fields FROM ".
                   $tableName.
                   " WHERE (up='$base->up'".
                   " AND upversion='$base->upversion')";
        }
        else {
            $query="SELECT $fields FROM ".
                   $tableName.
                   " WHERE up='$base->up'";
        }
    }
    if ($relType=="children") {
        if (!isset($base->id)) {
            $txt="id not set, ".$errTxt[wrong_object];
            $infoText[] = $langTxt["DBT30"].": ".$txt;
            return wrong_object;
        }
        if (isset($base->version)) {
            $query="SELECT $fields FROM ".
                   $tableName.
                   " WHERE (up='".$base->id."'".
                   " AND upversion='".
                   $base->version."')";
        }
        else {
            $query="SELECT $fields FROM ".
                   $tableName.
                   " WHERE up='".$base->id."'";
        }
    }        
    $query.=" ORDER BY treeidx";
    return ok;
}
function getRelativesFromDb($base, $relType,$fields,&$relatives)
{
    global $errTxt;
    $relatives=array();
    $ret=makeSqlGetRelatives($base, $relType,$fields,$query);
    if ($ret!=ok) {
        return $ret;
    }
    $ret=$base->loadObjectsSQL($query,$relatives,TRUE);
    if ($ret!=ok && $ret!=not_found_in_db) {
        return $ret;
    }
    return ok;
}    
function getBrothersFromDb($base, &$brothers,$fields="*")
{
    $ret=getRelativesFromDb($base, "brothers",$fields,$brothers);
    return $ret;
}
function getChildrenFromDb($base, &$children,$fields="*")
{
    $ret=getRelativesFromDb($base, "children",$fields,$children);
    return $ret;
}
function getLastChildFromDb($base, &$child,$fields="*")
{
    $child=0;
    $ret=getChildrenFromDb($base,$children,$fields);
    if ($ret!=ok) {
        return $ret;
    }
    if (is_array($children)&&isset($children[0])) {
        $child=$children[count($children)-1];
    }
    return $ret;
}
function getLastGrandChildFromDb($base, &$child,$fields="*")
{
    $child=0;
    $ret=getChildrenFromDb($base,$children,$fields);
    if ($ret!=ok) {
        return $ret;
    }
    if (is_array($children)&&isset($children[0])) {
        $ret=getLastGrandChildFromDb($children[count($children)-1],
                                $child,$fields);
        if ($ret!=ok) {
            return $ret;
        }
        if (!is_object($child)) {
            $child=$children[count($children)-1];
        }
    }
    return $ret;
}
function getAncestors(&$base,&$ancestors,$rootId=0,$withOwn=0)
{
    global $connectionLink; 
    static $deep=0;
    global $errTxt;
    global $langTxt;
    global $infoText;
    if ($deep==0) $ancestors=array();
    if (!isset($base->up)) {
        $txt=$errTxt[wrong_object];
        $infoText[] = $langTxt["DBT40"].": ".$txt;
        return wrong_object;
    }
    $deep++;
    if ($deep>10) {
        $txt=$errTxt[deep_struct];
        $infoText[] = $txt;
        $deep--;
        return deep_struct;
    }    
    if ($withOwn!=0) $ancestors[] = $base;
    if ($base->up==0 || $base->up==$rootId) {
        $deep--;
        return ok;
    }
    $className = get_class($base);
    $a = new $className;
    $a->id=$base->up;
    $ret = $a->load();
    if ($ret==not_found_in_db) {
        $deep--;
        $txt=$errTxt[no_father];
        $infoText[] = $txt;
        return no_father;
    }
    if ($ret!=ok) {
        $deep--;
        return $ret;
    }
    $ancestors[] = $a;
    if ($a->up==0 || $a->id==$rootId) {
        $deep--;
        return ok;
    }    
    $ret = getAncestors($a,$ancestors,$rootId);
    $deep--;
    return $ret;
}
?>
