<?php
$forum_typeInfo = 
    array(
        "attributes"=>array(   
            "id"=>array(
                "type"=>"INT",
                "min" =>"0",
                "unsigned",
                "not null",
                "auto increment",
                "form hidden"
            ),
            "up"=>array(
                "type"=>"INT",
                "min" =>"0",
                "unsigned",
                "not null",
                "form hidden",
                "private"
            ),            
            "name"=>array(
                "type"=>"VARCHAR",
                "max" =>"120",
                "min" =>"1",
                "not null",
                "list",
                "organiser"
            ),            
            "wholeniceurl"=>array(
                "type"=>"VARCHAR",
                "max" =>"250",
                "not null",
                "form invisible"
            ),            
            "niceurl"=>array(
                "type"=>"VARCHAR",
                "max" =>"250",
                "not null"
            ),            
            "treeidx"=>array(
                "type"=>"INT",
                "min" =>"0",
                "unsigned",
                "not null",
                "form hidden",
                "organiser",
                "centered",
                "private"
            ),            
            "treedepth"=>array(
                "type"=>"INT",
                "min" =>"0",
                "unsigned",
                "not null",
                "form hidden",
                "organiser",
                "centered",
                "private"
            ),            
            "status"=>array(
                "type"  =>"ENUM",
                "values"=>array( "forum_opened", "forum_closed" ),
                "not null",
                "list",
                "centered"
            ),            
            "description"=>array(
                "type"=>"TEXT",
                "not null",
                "rows"=>5,
                "cols"=>80
            ),
            "iscat"=>array(
                "type"  =>"ENUM",
                "values"=>array( "yes", "no" ),
                "not null",
                "default"=>"no"
            ),
            "portalNews"=>array(
                "type"  =>"ENUM",
                "values"=>array( "yes", "no" ),
                "not null",
                "default"=>"no"
            ),
            "allowAnonym"=>array(
                "type"  =>"ENUM",
                "values"=>array( "yes", "no" ),
                "not null",
                "default"=>"no"
            ),
            "readgroup"=>array(
                "type"=>"INT",
                "unsigned",
                "not null"
            ),
            "writegroup"=>array(
                "type"=>"INT",
                "unsigned",
                "not null"
            ),
            "topicgroup"=>array(
                "type"=>"INT",
                "unsigned",
                "not null"
            ),
            "hasChild"=>array(
                "type"  =>"ENUM",
                "values"=>array( "yes", "no" ),
                "not null",
                "form hidden",
                "default"=>"no"
            ),
            "topicnum"=>array(
                "type"=>"INT",
                "min" =>"0",
                "unsigned",
                "not null",
                "form hidden",
                "list",
                "centered",
                "private"
            ),
            "postnum"=>array(
                "type"=>"INT",
                "min" =>"0",
                "unsigned",
                "not null",
                "form hidden",
                "list",
                "centered",
                "private"
            ),
            "creationtime"=>array(
                "type"=>"INT",
                "form invisible",
                "private"
            ),
            "lastpost"=>array(
                "type"=>"INT",
                "form hidden",
                "list",
                "not null",
                "private"
            ),
            "moderator"=>array(
                "type"=>"VARCHAR",
                "max" =>"250",
                "list",
                "not null"
            ),
            "ownerId"=>array(
                "type"=>"INT",
                "unsigned",
                "form invisible",
                "private"
            ),
            "htmlTitle"=>array(
                "type"  =>"VARCHAR",
                "max"  =>"255",
                "not null"
            ),
            "htmlKeywords"=>array(
                "type"  =>"VARCHAR",
                "max"  =>"255",
                "not null"
            ),
            "htmlDescription"=>array(
                "type"  =>"VARCHAR",
                "max"  =>"255",
                "not null"
            )       
        ),
        "primary_key"=>array(
            "id"
        ),
        "tableName"=>"forum_zorum" );
class Forum extends Object
{
    function Forum()
    {
        $this->up=0;
        $this->moderator="";
    }
    function hasObjectRights(&$hasRight, $method, $giveError=FALSE)
    {
        global $zorumrecognised, $zorumauthlevel, $zorumuser;
        global $generalRight;
        $generalRight = TRUE;
        if( $method==Priv_load )
        {
            $hasRight=TRUE;
        }    
        elseif( $zorumrecognised && $zorumuser->isAdm=="yes" )
        {
            $hasRight=TRUE;
        }
        else
        {
            $hasRight=FALSE;
        }
        if( !$hasRight && $giveError )
        {
            global $infoText;
            global $errTxt;
            $txt = $errTxt[permission_denied];
            $infoText[] = $txt;
            return permission_denied;
        }
        return ok;
    }
    function create($overrulePrivilege=FALSE)
    {
        return forumforum_create($this,$overrulePrivilege);
    }     
    function modify($overrulePrivilege=FALSE)
    {
        return forumforum_modify($this,$overrulePrivilege);
    }
    function delete($whereFields="",$overrulePrivilege=FALSE)
    {
        return forumforum_delete($this,$whereFields,
                                 $overrulePrivilege);
    }
    function showNewToolPlusUrl(&$roll)
    {
        global $rollid;
        if (isset($rollid)) $roll->up = $rollid;
        return ok;
    }    
    function showNoNewmessForumImage()
    {
        global $langTxt;
        return "<img src='i/nonewmess.gif' width='19'".
               " height='12' alt='".$langTxt["nonewmess"]."'".
               " title='".$langTxt["nonewmess"]."'>";
    }
    function showNewmessForumImage()
    {
        global $langTxt;
        return "<img src='i/newmessforum.gif' width='19'".
               " height='19' alt='".$langTxt["newmess"]."'".
               " title='".$langTxt["newmess"]."'>";
    }
    function showClosedForumImage()
    {
        global $langTxt;
        return "<img src='i/lockfolder.gif' width='25'".
               " height='20' alt='".$langTxt["closedforum"]."'".
               " title='".$langTxt["closedforum"]."'>";
    }
    function showOneRow($rights,&$s)
    {
        if ($this->iscat=="no") return showOneRow($this,$rights,$s);
        else return showOneRow($this,$rights,$s,"category");
    }
    function showListEntry($rights)
    {
        if ($this->iscat=="no") return showListEntry($this,$rights);
        global $maxdepth;
        $f=6+$maxdepth;
        $s="<td class='forumrow3' colspan='$f' align='left'>".
           "<span class='listItemTitle'>";
        global $forumView;
        if( $forumView=="flat" && $this->hasChild=="yes" ) {
            goForward( $tempRoll, "subForum", $this );
            $s.=$tempRoll->generAnchor(htmlspecialchars($this->name),
                                       "listItem");
        }        
        else $s.=htmlspecialchars($this->name);
        $s.="</span>";
        if ($this->description!="") {
            $s.="<br><span class='forumDescription'>";
            $s.=htmlspecialchars($this->description);
            $s.="</span>";
        }
        $s.="</td>";
        return $s;
    }
    function generForm(&$s)
    {
        return forumforum_generForm($this,$s);
    }    
    function showNavBar(&$s, $withLink=FALSE)
    {
        return forumforum_showNavBar($this,$s, $withLink);
    }
    function showListVal($attr, $index="", $filledFromSavedValues=TRUE)
    {
        return forumforum_showListVal($this,$attr,$index,
                                      $filledFromSavedValues);
    }
    function showBelowList(&$s)
    {
        return forumforum_showBelowList($this,$s);
    }
    function showDetailsMethods()
    {
        return forumforum_showDetailsMethods($this);
    }
    function showHtmlKeywords(&$s, $recursive=FALSE)
    {    
        global $forumView, $zorumroll;
        global $showMetaTags;
        $ret = ok;
        $s = "";
        if( $showMetaTags=="no" )
        {
            return ok;
        }
        $ret = $this->cacheFatherObjects();
        if( $ret ) {
            return $ret;
        }
        global $fatherForumList;
        if( $this->htmlKeywords )
        {
            $s.="<META NAME='keywords' CONTENT='$this->htmlKeywords'>\n";
        }
        elseif( $recursive )
        {
            return $ret;
        }
        elseif( $forumView=="flat" && $zorumroll->rollid )
        {
            $reverseList = array_reverse($fatherForumList);
            foreach( $reverseList as $fatherForum )
            {
                $ret = $fatherForum->showHtmlKeywords($s, TRUE);
                if( $s ) break;
            }
            if (!$s ) $ret = Object::showHtmlKeywords($s);
        }
        else $ret = Object::showHtmlKeywords($s);
        return $ret;
    } 
    function showHtmlDescription(&$s, $recursive=FALSE)
    {
        global $forumView, $zorumroll;
        global $showMetaTags;
        $ret = ok;
        $s = "";
        if( $showMetaTags=="no" )
        {
            if( $this->description )
            {
                $s.="<META NAME='description' CONTENT='".
                    htmlspecialchars($this->description).
                    "'>\n";
            }
            elseif( $this->name )
            {
                $s.="<META NAME='description' CONTENT='".
                    htmlspecialchars($this->name)."'>\n";
            }    
            return ok;
        }
        $ret = $this->cacheFatherObjects();
        if( $ret ) {
            return $ret;
        }
        global $fatherForumList;
        if( $this->htmlDescription )
        {
            $s.="<META NAME='keywords' CONTENT='$this->htmlDescription'>\n";
        }
        elseif( $recursive )
        {
            return $ret;
        }
        elseif( $forumView=="flat" && $zorumroll->rollid )
        {
            $reverseList = array_reverse($fatherForumList);
            foreach( $reverseList as $fatherForum )
            {
                $ret = $fatherForum->showHtmlDescription($s, TRUE);
                if( $s ) break;
            }
            if (!$s ) $ret = Object::showHtmlDescription($s);
        }
        else $ret = Object::showHtmlDescription($s);
        return $ret;
    } 
    function showHtmlTitle(&$s, $recursive=FALSE)
    {
        global $forumView, $zorumroll;
        global $showMetaTags;
        $ret = ok;
        $s = "";
        if( $showMetaTags=="no" )
        {
            if( $this->name )
            {            
                $s.="<TITLE>".htmlspecialchars($this->name)."</TITLE>\n";
            }    
            return ok;
        }
        $ret = $this->cacheFatherObjects();
        if( $ret ) {
            return $ret;
        }
        global $fatherForumList;
        if( $this->htmlTitle )
        {
            $s.="<TITLE>$this->htmlTitle</TITLE>\n";
        }
        elseif( $recursive )
        {
            return $ret;
        }
        elseif( $forumView=="flat" && $zorumroll->rollid )
        {
            $reverseList = array_reverse($fatherForumList);
            foreach( $reverseList as $fatherForum )
            {
                $ret = $fatherForum->showHtmlTitle($s, TRUE);
                if( $s ) break;
            }
            if (!$s ) $ret = Object::showHtmlTitle($s);
        }
        else $ret = Object::showHtmlTitle($s);
        return $ret;
    } 
    function cacheFatherObjects()
    {
        global $fatherForumList;
        global $zorumroll;
        if( (!isset($this->id) || !$this->id) && $zorumroll->rollid ) 
        {
            $this->id=$zorumroll->rollid;
            $ret = load( $this );
            if( $ret ) {
                return $ret;
            } 
        }    
        if( !isset($fatherForumList) || !$fatherForumList)
        {
            $fatherForumList = array();
            if( isset($this->id) && $this->id )
            {
                $childForum = $this;
                while( $childForum->up )
                {
                    $childForum->id = $childForum->up;
                    $childForum->up = 0;
                    $ret = load( $childForum );
                    if( $ret ) 
                    {
                        return $ret;
                    } 
                    $fatherForumList[] = $childForum;
                }
                $fatherForumList = array_reverse($fatherForumList);
            }    
        }
        return ok;
    }
    function cacheChildrenObjects()
    {
        global $childrenForumList;
        global $zorumroll;
        if( !isset($this->id) && $zorumroll->rollid ) 
        {
            $this->id=$zorumroll->rollid;
            $ret = load( $this );
            if( $ret ) {
                return $ret;
            } 
        }    
        if( !isset($childrenForumList) || !$childrenForumList)
        {
            if( $this->id )
            {
                $query="SELECT treeidx FROM forum_zorum".
                       " WHERE up<=$this->up".
                       " AND treeidx>$this->treeidx";
                       " AND treedepth=$this->treedepth".
                       " ORDER BY treeidx LIMIT 1";
                $result=mysql_query($query);
                if( $result==0 ) {
                    $infoText[] = mysql_error();
                    return general_mysql_error;
                }
                $num = mysql_num_rows($result);
                if ($num) {
                    $row=mysql_fetch_row($result);
                    $tidx=$row[0];
                }
                $query="SELECT * FROM forum_zorum".
                       " WHERE treeidx>$this->treeidx";
                if ($num>0) $query.=" AND treeidx<$tidx";
                $query.=" ORDER BY treeidx";
                $childrenForumList = new Forum;
                $ret=$childrenForumList->loadObjectsSQL($query,
                                    $childrenForumList,TRUE);
                if ($ret!=ok && $ret!=not_found_in_db) {
                    return $ret;
                }
            }    
            else $childrenForumList = array();
        }
        return ok;
    }
}
?>
