<?php
function forumforum_create(&$base,$overrulePrivilege=FALSE)
{
    global $submit;
    global $langTxt;
    global $whatHappened;
    $whatHappened = "form_submitted";
    if( $submit==$langTxt["cancel"] )
    {   
        global $infoText;
        $infoText[] = $langTxt["operation_cancelled"];
        return ok;
    } 
    if (isset($base->niceurl) && $base->niceurl!="") {
        $ret=createNiceUrlForum($base,$niceFileName);
        if ($ret!=ok) {
            $whatHappened = "invalid_form";
            return ok;
        }
    }    
    $ret=treeListPreCreate($base,"");
    if ($ret!=ok) {
        return $ret;
    }
    $ret=makeModeratorArray($base->moderator,$modArr);
    if ($ret || $whatHappened=="invalid_form") {
        return $ret;
    }
    $ret = privilegeCreate($base);
    if ($ret || $whatHappened=="invalid_form") {
        return $ret;
    }
    foreach( $modArr as $user )
    {
        $user->isMod="yes";
        $ret = modify($user);
        if ($ret!=ok) {
            return $ret;
        }
    }
    global $zorumglobalstat;
    $zorumglobalstat->forumnum++;
    $ret = modify($zorumglobalstat);
    if ($ret!=ok) {
        return $ret;
    }
    global $searchEngine;
    if( $searchEngine=="yes" )
    {
        $ret = specForum();
        if ($ret!=ok) {
            return $ret;
        }
    }
    if (isset($base->niceurl) && $base->niceurl!="") {
        $ret=writeNiceUrl($base->id,$niceFileName);
        if ($ret!=ok) {
            $infoText[] = $langTxt["nice_err"];
            return ok;
        }
    }
    return ok;     
}    
function forumforum_modify(&$base,$overrulePrivilege=FALSE)
{
    global $submit;
    global $langTxt;
    global $errTxt;
    global $errMsg;
    global $infoText;
    global $whatHappened;
    $whatHappened = "form_submitted";
    if( $submit==$langTxt["cancel"] )
    {   
        global $infoText;
        $infoText[] = $langTxt["operation_cancelled"];
        return ok;
    } 
    $origForum = new Forum;
    $origForum->id=$base->id;
    $ret=$origForum->load();
    if ($ret!=ok) {
        return $ret;
    }
    if( $base->moderator!=$origForum->moderator )
    {
        $ret=makeModeratorArray($base->moderator,$modArr);
        if ($ret || $whatHappened=="invalid_form") {
            return $ret;
        }
        foreach( $modArr as $user )
        {
            $user->isMod="yes";
            $ret = modify($user);
            if ($ret!=ok) {
                return $ret;
            }
        }
    }
    if (isset($base->niceurl) && $base->niceurl!="") {
        global $niceFileName;
        $ret=createNiceUrlForum($base,$niceFileName);
        if ($ret==wrong_object) {
            $whatHappened="";
            $infoText[count($infoText)-1]="";
        }
        elseif ($ret!=ok) {
            $whatHappened = "invalid_form";
            return ok;
        }
    }    
    $ret = privilegeModify($base,$overrulePrivilege);
    if ($ret || $whatHappened=="invalid_form") {
        return $ret;
    }
    global $searchEngine;
    if( $searchEngine=="yes" )
    {
        $ret = specForum();
        if ($ret!=ok) {
            return $ret;
        }
    }
    if (isset($base->niceurl) && $base->niceurl!="" && 
        $base->niceurl!=$origForum->niceurl)
    {
        if ($base->wholeniceurl!=$origForum->wholeniceurl) {
            $ret=makeForumDir($base,FALSE);
            if ($ret!=ok) {
                return $ret;
            }
            if ($origForum->niceurl!="") {
                $ret=deleteForumDir($origForum);
                if ($ret!=ok) {
                    return $ret;
                }
            }
        }
    }
    return ok;     
} 
function forumforum_delete(&$base,$whereFields="",$overrulePrivilege=FALSE)
{
    global $submit;
    global $langTxt;
    global $whatHappened;
    global $infoText;
    global $specBlockSize;
    $whatHappened = "form_submitted";
    if( $submit==$langTxt["no"] )
    {   
        $infoText[] = $langTxt["operation_cancelled"];
        return ok;
    } 
    $ret=privilegeDelete($base,$whereFields="",$overrulePrivilege);
    if ($ret==not_found_in_db) {
        $infoText[] = $langTxt["no_such_object"];
        return ok;
    }
    if ($ret!=ok) {
        return $ret;
    }
    global $forumtopic_typeInfo;
    $query="SELECT * FROM ". $forumtopic_typeInfo["tableName"].
           " WHERE pid=$base->id";
    $tmp = new ForumTopic;
    $ret=loadObjectsSQL( $tmp, $query,$topics);
    if ($ret!=ok && $ret!=not_found_in_db) {
        return $ret;
    }
    foreach($topics as $topic) {
        $ret=$topic->delete("",TRUE);
        if ($ret!=ok) {
            return $ret;
        }
    }
    global $zorumglobalstat;
    $zorumglobalstat->forumnum--;
    $ret = modify($zorumglobalstat);
    if ($ret!=ok) {
        return $ret;
    }
    global $zorumroll;
    if( $zorumroll->frommethod=="showdetails" )      
    {
        $zorumroll->frommethod = "showhtmllist";
        $zorumroll->fromid = 0;
    }
    global $searchEngine;
    if( $searchEngine=="yes" )
    {
        $ret = specForum();
        if ($ret!=ok) {
            return $ret;
        }
        $navbar="<a href='forum.html'>".$langTxt["forums"]."</a>";
        $navbar.=" &gt; ";
        $navbar.=$langTxt["topics_with_newpost_listtitle"];
        $ret=specTopic(0,$navbar,0,0,$specBlockSize,FALSE,TRUE);
        if ($ret!=ok) {
            return $ret;
        }    
        $cmd="rm -f html/".$base->id."_hottopic.html";
        system($cmd);
        $cmd="rm -f html/".$base->id."_topic*";
        system($cmd);
    }
    if ($base->niceurl!="") {
        $ret=deleteForumDir($base);
        if ($ret!=ok) {
            return $ret;
        }
    }
    return ok;     
}  
function specForum()
{
    global $langTxt;
    global $submit;
    $ret = loadAndShowSpecForum($forumList,$s);
    $f = fopen("html/forum.html", "w");
    if( !$f )
    {
        $infoText[] = $langTxt["noPermissionInFileSystem"];
        return nok;
    }
    $success = fputs($f, $s);
    $success = fclose($f);
    return ok;
}
function loadAndShowSpecForum(&$forumList,&$s)
{
    global $zorumSkin,$langTxt;
    global $specBlockSize;
    $s="";
    $query = "SELECT * FROM forum_zorum WHERE readgroup='0' ORDER BY treeidx";
    $forumList = new Forum;
    $forumList->removeFromTypeInfo("status", "list");        
    $ret = $forumList->loadObjectsSQL($query,$forumList, TRUE);
    $noErr = $ret==ok || $ret==not_found_in_db;
    if ($ret!=ok) 
    {
        return $ret;
    }   
    $length = sizeof($forumList);
    $maxdepth=0;
    foreach($forumList as $obj) 
    {
        if( $obj->treedepth > $maxdepth ) $maxdepth=$obj->treedepth;
    }
    $tempRoll = new Roll;
    $tempRoll->scriptname = "../z_forum_show.php";
    $tempRoll->method = "showhtmllist";
    $tempRoll->class = "forum";
    $navBarText=$langTxt["forums"];
    $s=generateFileHeader($tempRoll, $navBarText);  
    $s.="<table border='0' width='100%' cellpadding='0'".
        " cellspacing='0'><tr><td bgcolor='".$zorumSkin->bg."'>\n";
    $s.="<table border='0' width='100%' cellpadding='2' ".
        "cellspacing='1'>\n";
    $s.="<tr bgcolor='".$zorumSkin->headbg."'>";
    $maxdepth=0;
    for($j=0; $j<$length; $j++)
    {
        if( $forumList[$j]->treedepth > $maxdepth ) $maxdepth=$forumList[$j]->treedepth;
    }
    $csp = $maxdepth + 1;
    $s.="<th nowrap colspan='$csp'>";
    $s.=$langTxt["forum_name"];
    $s.="</th>\n";
    $s.="<th nowrap>".$langTxt["forum_topicnum"]."</th>\n";
    $s.="<th nowrap>".$langTxt["forum_postnum"]."</th>\n";
    $s.="<th nowrap>".$langTxt["lastpost"]."</th>\n";
    $s.="<th nowrap>".$langTxt["forum_moderator"]."</th>\n";
    $s.="</tr>\n";
    for($j=0; $j<$length; $j++) {
        if( $forumList[$j]->iscat=="yes" )
        {
            $s.="<tr bgcolor='".$zorumSkin->category."'>";
            $modulus=5;
            for($k=0;$k<$forumList[$j]->treedepth;$k++) {
                $l=$k % $modulus;
                $cellbgName = "cellbg$l";
                $s.="<td>";
                $s.="<img src='../i/b.gif' width='10'>";
                $s.="</td>\n";
            }
            $c = $maxdepth + 5 - $forumList[$j]->treedepth;
            $s.="<td colspan='$c' align='left'>";
            $s.=htmlspecialchars($forumList[$j]->name);
            if ($forumList[$j]->description!="") {
                $s.="<br><font color='gray'>";
                $s.=htmlspecialchars($forumList[$j]->description);
                $s.="</font>";
            }
            $s.="</td></tr>\n";
        }
        else
        {
            $s.="<tr bgcolor='".$zorumSkin->cellbg."'>";
            $modulus=5;
            for($k=0;$k<$forumList[$j]->treedepth;$k++) {
                $l=$k % $modulus;
                $cellbgName = "cellbg$l";
                $s.="<td>";
                $s.="<img src='../i/b.gif' width='10'>";
                $s.="</td>\n";
            }
            $c=$forumList[$j]->treedepth % $modulus;
            $cellbgName = "cellbg$c";
            $s.="<td ";
            $csp = $maxdepth + 1 - $forumList[$j]->treedepth;
            if ($csp>1) $s.=" colspan='$csp'";
            $s.=">";
            $s1=htmlspecialchars($forumList[$j]->name);
            $block = ceil(($forumList[$j]->topicnum) / $specBlockSize)-1;
            if ($forumList[$j]->topicnum==0) $s.=$s1;
            else {
                $s.="<a href='".$forumList[$j]->id.
                "_topic_$block.html'>$s1</a>\n";
            }
            if ($forumList[$j]->description!="") {
                $s.="<br><font color='gray'>";
                $s.=htmlspecialchars($forumList[$j]->description);
                $s.="</font>";
            }
            $s.="</td>\n";
            $s.="<td>".$forumList[$j]->topicnum."</td>\n";
            $s.="<td>".$forumList[$j]->postnum."</td>\n";
            if ($forumList[$j]->lastpost==0) {
                $s.="<td>".$langTxt["never"]."</td>\n";
            }
            else {
                $s.="<td><a href='".$forumList[$j]->id."_hottopic.html'>".
                showTimestamp($forumList[$j]->lastpost)."</a></td>\n";
            }
            $s.="<td>";
            $s1="";
            $mods=explode(",",$forumList[$j]->moderator);
            if (isset($mods[0])&&$mods[0]!="") {
                for($k=0;isset($mods[$k]);$k++) {
                    if ($s1!="") $s1.=",";
                    $mod=trim($mods[$k]);
                    $s1.=htmlspecialchars($mod);
                }
                $s.=$s1;
            }
            if ($s1=="") $s.=$langTxt["notmoderated"];                    
            $s.="</td>\n";
            $s.="</tr>\n";
        }    
    }
    $s.="</table>\n";
    $s.="</td></tr></table>\n";
    $s.="<br>";
    $s.="<a href='hottopic.html'>$langTxt[snap_hottopic]</a>";
    $s.="<br>";
    $s.= showPFooter();
    $s.="</body>";
    $s.="</table>\n";
    $s.="</td></tr></table>\n";
    return ok;
}
function createNiceUrlForum(&$base,&$fname)
{
    global $whatHappened,$infoText,$langTxt;
    $fname="";
    $father = new Forum;
    if ($base->up==0) $father->wholeniceurl="";
    else {
        $father->id=$base->up;
        $ret = load($father);
        if( $ret ) {
            return $ret;
        }
    }
    $dir=$father->wholeniceurl;
    if ($dir!="") $dir.="/";
    $dir.=$base->niceurl;
    $ret=@is_dir($dir);
    $base->wholeniceurl=$dir;
    if ($ret) {
        $whatHappened="invalid_form";
        $infoText[] = sprintf($langTxt["nice_al_ex"],$dir);
        return wrong_object;
    }
    $ret = @mkdir($dir, 0777);
    if( !$ret ) {
        $whatHappened="invalid_form";
        $infoText[] = sprintf($langTxt["nice_create_err"],$dir);
        return nok;
    }
    $fname="$dir/index.php";
    $f=fopen($fname,"w");
    if (!$f) {
        $whatHappened="invalid_form";
        $infoText[] = sprintf($langTxt["nice_create_f_err"],$fname);
        return nok;
    }        
    fclose($f);
    return ok;
}
function writeNiceUrl($rollid,$fname,$readmore=FALSE)
{
    global $whatHappened,$infoText,$langTxt;
    $s="";
    $s.="<"."?php\n\$sourceDir=\"";
    $niceDepth=substr_count($fname,"/");
    for($i=0;$i<$niceDepth;$i++) {
        if ($i+1<$niceDepth) $s.="../";
        else $s.="..";
    }
    $s.="\";\n\$dotDot=\$sourceDir;\n";
    $s.="\$rollid=$rollid;\n";
    if ($readmore) $s.="\$method=\"readmore\";\n";
    $s.="include(\"\$sourceDir/portal.php\");\n?".">";
    $f=fopen($fname,"w");
    if (!$f) {
        $whatHappened="invalid_form";
        $infoText[] = sprintf($langTxt["nice_create_f_err"],$fname);
        return nok;
    }
    fwrite($f,$s);
    fclose($f);
    return ok;
}
function deleteForumDir($base)
{
    global $childrenForumList;
    $childrenForumList=0;
    $ret=$base->cacheChildrenObjects();
    if( $ret!=ok ) {
        return $ret;
    }
    $num = count($childrenForumList);
    for($i=$num-1;$i>=0;$i--) {
        $f = $childrenForumList[$i];
        $ret=deleteNiceUrlTopics($f->id,$f->wholeniceurl);
        if ($ret!=ok) {
            return $ret;
        }
        $fil=$f->wholeniceurl."/index.php";
        $ret=unlink($fil);
        $ret=rmdir($f->wholeniceurl);        
    }
    $ret=deleteNiceUrlTopics($base->id,$base->wholeniceurl);
    if ($ret!=ok) {
        return $ret;
    }
    $fil=$base->wholeniceurl."/index.php";
    $ret=unlink($fil);
    $ret=rmdir($base->wholeniceurl);        
    return ok;
}
function makeForumDir($base,$makeOwn=TRUE)
{
    if (isset($base->niceurl) && $base->niceurl!="") {
        if ($makeOwn) {
            $ret=createNiceUrlForum($base,$niceFileName);
            if ($ret!=ok) {
                return $ret;
            }
            writeNiceUrl($base->id,$niceFileName);
            $ret=modify($base);
            if ($ret!=ok) {
                return $ret;
            }
        }
        else {
            global $niceFileName;
            writeNiceUrl($base->id,$niceFileName);
        }
        $ret=writeNiceUrlTopics($base,$base->wholeniceurl);
        if ($ret!=ok) {
            return $ret;
        }
    }
    global $childrenForumList;
    $childrenForumList=0;
    $ret=$base->cacheChildrenObjects();
    if( $ret!=ok ) {
        return $ret;
    }
    foreach($childrenForumList as $f) {
        if (isset($f->niceurl) && $f->niceurl!="") {
            $ret=createNiceUrlForum($f,$niceFileName);
            if ($ret!=ok) {
                return $ret;
            }
        }
        else continue;
        writeNiceUrl($f->id,$niceFileName);
        $ret=writeNiceUrlTopics($f,$f->wholeniceurl);
        if ($ret!=ok) {
            return $ret;
        }  
        $ret=modify($f);
        if ($ret!=ok) {
            return $ret;
        }
    }
    return ok;
}
?>
