<?php
define("Group_OnlyAdmin", 196969);
define("Group_OnlyAdminAndMod", 196970);
define("Group_All", 0);
define("Group_None", -1);
$group_typeInfo =
    array(
        "attributes"=>array(   
            "id"=>array(
                "type"=>"INT",
                "min" =>"0",
                "unsigned",
                "not null",
                "auto increment",
                "form hidden"
            ),
            "name"=>array(
                "list",
                "type"=>"VARCHAR",
                "max" =>"255",
                "min" =>"1",
                "not null",
                "sorta"
            ),            
            "comment"=>array(
                "type"=>"TEXT",
                "rows" => 10,
                "cols" => 50,
                "not null",
                "list",
                "sorta"
            ),
            "moderator"=>array(
                "type"=>"VARCHAR",
                "max" =>"250",
                "list",
                "not null"
            ),            
            "ownerId"=>array(
                "type"=>"INT",
                "unsigned",
                "form invisible",
                "private"
            )
        ),
        "primary_key"=>array("id"),
        "unique_keys"=>"name",            
        "tableName"=>"group_zorum"
    );
class Group extends Object
{
    function hasObjectRights(&$hasRight, $method, $giveError=FALSE)
    {
        global $zorumrecognised, $zorumauthlevel, $zorumuser;
        global $generalRight;
        $hasRight = FALSE;
        $generalRight = FALSE;
        if( $method==Priv_load ) {
            $hasRight=TRUE;
            $generalRight = TRUE;
        }
        elseif( $zorumauthlevel<=Loginlib_GuestLevel ) {
            $hasRight=FALSE;
            $generalRight = TRUE;
        }  
        elseif( $zorumauthlevel>Loginlib_GuestLevel && 
                !$zorumrecognised )
        {
            $hasRight=FALSE;
            $generalRight = TRUE;
        }        
        else
        {
            if( $zorumuser->isAdm=="yes" )
            {
                if( $method==Priv_delete )
                {
                    global $langTxt;
                    $query = "SELECT readgroup, writegroup, name FROM forum_zorum";
                    $forums = new Forum;
                    $ret = loadObjectsSql( $forums, $query, $forums );
                    if ($ret!=ok) {
                        return $ret;
                    }
                    foreach( $forums as $forum )
                    {
                        $hasRight=TRUE;
                        if( $forum->readgroup==$this->id || 
                            $forum->writegroup==$this->id )
                        {
                            if( $hasRight ) $txt = $langTxt["groupUsed"]."<br>";
                            $txt.=$forum->name."<br>";
                            $hasRight = FALSE;
                        }    
                    }
                    $generalRight = FALSE;
                    if( !$hasRight )
                    {
                        global $textForGroupDelete;
                        $textForGroupDelete=$txt.$langTxt["cantDelete"];
                        return nok;
                    }    
                    $hasRight=TRUE;
                }
                else
                {
                    $generalRight = TRUE;
                    $hasRight=TRUE;
                }
            }
            elseif( $zorumuser->isMod=="yes" )
            {
                $moderators = split( ", *", $this->moderator );
                if( in_array($zorumuser->name, $moderators) )
                {
                    if( $method==Priv_delete )
                    {
                        $hasRight=FALSE;
                        $generalRight=FALSE;
                    }
                    else
                    {
                        $hasRight=TRUE;
                        $generalRight=FALSE;
                    }
                }    
            }
        }
        if( !$hasRight && $giveError )
        {
            global $infoText;
            global $errTxt;
            $txt = $errTxt[permission_denied];
            $infoText[] = $txt;
            return permission_denied;
        }
        return ok;
    } 
    function create($overrulePrivilege=FALSE)
    {
        global $errTxt;
        global $submit;
        global $whatHappened, $infoText;
        global $langTxt;
        $whatHappened = "form_submitted";
        if( $submit==$langTxt["cancel"] )
        {   
            $infoText[] = $langTxt["operation_cancelled"];
            return ok;
        } 
        $modArr = array();
        if ($this->moderator!="") {
            $ret=makeModeratorArray($this->moderator,$modArr);
            if ($ret || $whatHappened=="invalid_form") {
                return $ret;
            }
        }
        $ret = privilegeCreate($this, $overrulePrivilege);
        if ($ret || $whatHappened=="invalid_form") {
            return $ret;
        }
        foreach( $modArr as $user )
        {
            $user->isMod="yes";
            $ret = modify($user);
            if ($ret!=ok) {
                return $ret;
            }
        }
        return $ret;
    }
    function modify($overrulePrivilege=FALSE)
    {
        global $submit;
        global $langTxt;
        global $errTxt;
        global $errMsg;
        global $infoText;
        global $whatHappened;
        $whatHappened = "form_submitted";
        if( $submit==$langTxt["cancel"] )
        {   
            global $infoText;
            $infoText[] = $langTxt["operation_cancelled"];
            return ok;
        } 
        $origGroup = new Group;
        $origGroup->id=$this->id;
        $ret=$origGroup->load();
        if ($ret!=ok) {
            return $ret;
        }
        if( $this->moderator!=$origGroup->moderator )
        {
            if ($this->moderator!="") 
            {
                $ret=makeModeratorArray($this->moderator,$modArr);
                if ($ret || $whatHappened=="invalid_form") {
                    return $ret;
                }
                foreach( $modArr as $user )
                {
                    $user->isMod="yes";
                    $ret = modify($user);
                    if ($ret!=ok) {
                        return $ret;
                    }
                }
            }
        }
        $ret = privilegeModify($this,$overrulePrivilege);
        if ($ret || $whatHappened=="invalid_form") {
            return $ret;
        }
        return ok;     
    } 
    function delete($whereFields="",$overrulePrivilege=FALSE)
    {
        global $submit;
        global $langTxt;
        global $whatHappened;
        global $infoText;
        $whatHappened = "form_submitted";
        if( $submit==$langTxt["no"] || $submit==$langTxt["returnToList"])
        {   
            $infoText[] = $langTxt["operation_cancelled"];
            return ok;
        } 
        $ret=privilegeDelete($this,$whereFields="",$overrulePrivilege);
        if ($ret==not_found_in_db) {
            $infoText[] = $langTxt["no_such_object"];
            return ok;
        }
        if ($ret!=ok) {
            return $ret;
        }
        $query="DELETE FROM groupmember_zorum WHERE groupId='$this->id'";
        $result=mysql_query($query);
        if( $result==0 ) 
        {
            $txt = sprintf( $errTxt[general_mysql_error], mysql_error() );
            $infoText[] = $langTxt["DBP30"].": ".$txt;
            return general_mysql_error;
        }
        global $zorumroll;
        if( $zorumroll->frommethod=="showdetails" )      
        {
            $zorumroll->frommethod = "showhtmllist";
            $zorumroll->fromid = 0;
        }
        return ok;     
    }
    function deleteForm(&$s)
    {
        global $langTxt, $infoText;
        $ret=$this->load();  
        if ($ret!=ok) 
        {
            return $ret;
        }
        $ret=$this->hasObjectRights($hasRight, Priv_delete, TRUE);
        if( $ret==permission_denied ) 
        {
            return $ret;
        }
        $s="";
        goForward( $tempRoll, "formService" );
        $tempRoll->id = $this->id;
        if( $ret==nok )
        {
            global $textForGroupDelete;
            $s .= $tempRoll->generConfirmation( $textForGroupDelete, 
                                                "returnToList", "" );
        }
        else $s.=$tempRoll->generConfirmation($langTxt["beforeDelete"]);
        return ok;
    }
    function editGroupForm(&$s)
    {
        global $x;
        global $group_typeInfo;
        global $langTxt;
        $typ = & $group_typeInfo;
        $ret = load($this);
        if ($ret!=ok) 
        {
            return $ret;
        }
        $ret=$this->hasObjectRights($hasRight, Priv_modify, TRUE);
        if ($ret!=ok) 
        {
            return $ret;
        }
        goForward( $tempRoll, "formService" );
        $s="<form method='POST' enctype='multipart/form-data'".
           " action='$tempRoll->scriptname?x=$x'>\n";
        $s.=$tempRoll->generHiddenFields();
        $s.="<table border='0' class='line' width='100%'><tr><td >\n";
        $s.="<table border='0' width='100%' cellpadding='2' cellspacing='1'>\n";
        $s.="<tr><th class='headerbg' colspan='2'>";
        $s.="<span class='header'>";
        $s.=$langTxt["group_editGroupTitle"];
        $s.="</span></th></tr>";
        $s.=generHiddenField("id",$this->id);
        $fromListNames = array();
        $fromListValues = array();
        $toListNames = array();
        $toListValues = array();
        $allNames = array();
        $allValues = array();
        if( $this->id ) 
        {
            $query = "SELECT userId AS id, u.name AS name ".
                     "FROM groupmember_zorum AS g, user_zorum AS u ".
                     "WHERE g.groupId='$this->id' AND g.userId=u.id ".
                     "ORDER BY name ASC";
            $usersInGroup = new User;         
            $ret = loadObjectsSql($usersInGroup, $query, $usersInGroup);
            if ($ret==general_mysql_error) 
            {
                return $ret;
            }
        }
        foreach( $usersInGroup as $user )
        {
            $toListNames[]=htmlspecialchars($user->name);
            $toListValues[]=$user->id;
        }
        $query = "SELECT id, name FROM user_zorum WHERE id!=name ORDER BY name ASC";
        $users = new User;
        $ret = loadObjectsSql($users, $query, $users);
        if ($ret!=ok) 
        {
            return $ret;
        }
        foreach( $users as $user )
        {
            $allNames[]=htmlspecialchars($user->name);
            $allValues[]=$user->id;
        }
        $fromListNames = array_diff( $allNames, $toListNames );
        $fromListValues = array_diff( $allValues, $toListValues );
        $fromListTitle=$langTxt["fromListTitle"];
        $toListTitle=$langTxt["toListTitle"];
        $fromListResult = "fromListResult[]";
        $toListResult = "toListResult[]";
        $fromListSize=20;
        $toListSize=20;
        $addButtonText=$langTxt["addButtonText"];
        $removeButtonText=$langTxt["removeButtonText"];
        $addAllButtonText=$langTxt["addAllButtonText"];
        $removeAllButtonText=$langTxt["removeAllButtonText"];
        $s.="<tr><td class='forumrow' colspan='2' align='center'>";
        $s.=generGroupSelection($fromListTitle, $toListTitle, 
                                $fromListNames, $toListNames,
                                $fromListValues, $toListValues,
                                $fromListResult, $toListResult,
                                $fromListSize, $toListSize,
                                $addButtonText, $removeButtonText,
                                $addAllButtonText,$removeAllButtonText,
                                "forumrow", "listItem");
        $s.="</td></tr>";
        $s.="<tr><td align='center' colspan='2' class='forumrow'>";
        $s.="<input type='submit' value='".$langTxt["ok"].
            "' name='submit'>\n";
        $s.="</td></tr>\n";
        $s.="\n</table>\n</td></tr></table>\n</form>\n";
    }
    function editGroup()
    {
        global $submit;
        global $langTxt;
        global $zorumroll;
        global $fromListResult;
        global $toListResult;
        global $whatHappened, $infoText;
        $s="";
        if( $submit==$langTxt["ok"] )
        {  
            $whatHappened = "form_submitted";
            $infoText[] = $langTxt["operation_cancelled"];
            return;
        } 
        $ret = load($this);
        if ($ret!=ok) 
        {
            return $ret;
        }
        $ret=$this->hasObjectRights($hasRight, Priv_modify, TRUE);
        if ($ret!=ok) 
        {
            return $ret;
        }
        if( $submit==$langTxt["addButtonText"] && 
            isset($fromListResult) && $fromListResult[0]!=0)
        {  
            $gm = new GroupMember;
            $gm->groupId = $this->id;
            foreach($fromListResult as $userId)
            {
                $gm->userId = $userId;
                $ret = create($gm);
                if ($ret) 
                {
                    return $ret;
                }
            }
        } 
        elseif( $submit==$langTxt["removeButtonText"] && 
                isset($toListResult)&& $toListResult[0]!=0)
        {  
            $gm = new GroupMember;
            $gm->groupId = $this->id;
            foreach($toListResult as $userId)
            {
                $gm->userId = $userId;
                $ret = delete($gm);
                if ($ret) 
                {
                    return $ret;
                }
            }
        } 
        elseif( $submit==$langTxt["addAllButtonText"] )
        {  
            $query = "SELECT id FROM user_zorum";
            $users = new User;
            $ret = loadObjectsSql($users, $query, $users);
            if ($ret!=ok) 
            {
                return $ret;
            }
            $gm = new GroupMember;
            $gm->groupId = $this->id;
            foreach( $users as $user )
            {
                $gm->userId = $user->id;
                $ret = create($gm);
                if ($ret==general_mysql_error) 
                {
                    return $ret;
                }
            }
        } 
        elseif( $submit==$langTxt["removeAllButtonText"] )
        {  
            $query = "DELETE FROM groupmember_zorum WHERE groupId='$this->id'";
            $result=mysql_query($query);
            if( $result==0 ) 
            {
                $txt = sprintf( $errTxt[general_mysql_error], mysql_error() );
                $infoText[] = $langTxt["DBP30"].": ".$txt;
                return general_mysql_error;
            }
        }
        $whatHappened = "reset_form"; 
        return ok;
    }
    function showGroupTool(&$s, $rights)
    {
        global $zorumuser;
        global $langTxt;
        $s="";
        if (!isset($rights[Priv_modify])) {
            $ret=$this->hasObjectRights($hasRight,Priv_modify);
            if ($ret!=ok) {
                return $ret;
            }
        }
        else $hasRight = $rights[Priv_modify];
        if ($hasRight) {    
            goForward( $tempRoll, "editGroup" );
            $tempRoll->id = $this->id;
            $s.=$tempRoll->generAnchor($langTxt["group_editGroupTitle"],"listItem");
        }
        return ok;
    }
    function showDelTool(&$s, $rights)
    {
        global $langTxt;
        $s="";
        if (!isset($rights[Priv_delete])) {
            $ret=$this->hasObjectRights($hasRight,Priv_delete);
            if ($ret==permission_denied) {
                return $ret;
            }
        }
        else $hasRight = $rights[Priv_delete];
        if ($hasRight || $ret==nok) {    
            goForward( $tempRoll, "delete" );
            $tempRoll->id = $this->id;
            $s.=$tempRoll->generImageAnchor("i/delete.gif",
                                    $langTxt["icon_delete"],16,20);
        }
        return ok;
    }
    function showNavBar(&$s)
    {
        global $zorumroll; 
        global $langTxt;
        $s = "";
        goForward( $tempRoll, "forums" );
        $s.=$tempRoll->generAnchor($langTxt["forums"]);
        $s.="&nbsp;>&nbsp;";
        if( $zorumroll->method=="showhtmllist" )
        {
            $s.=$langTxt["groups"];
        }
        else
        {
            goForward( $tempRoll, "groups", $this );
            $s.=$tempRoll->generAnchor($langTxt["polls"]);
        }    
        $s=insertSpanClass( $s, "navBar" );
        return ok;
    }
}
?>