<?php
function loadLatestNews(&$list,$pids=0)
{
    global $zorumuser;
    global $forummessage_typeInfo;
    global $portalBlockSize;
    $time = time();
    $query = "SELECT ".getAllColumns($forummessage_typeInfo, "m").
              "f.name AS forumname,viewnum,t.postnum AS postnum".
              ",poll,portalNews,f.wholeniceurl AS f_wholeniceurl,".
              " t.wholeniceurl AS t_wholeniceurl,prio FROM ".
              "forummessage_zorum AS m, forum_zorum AS f,".
              " forumtopic_zorum AS t ".
              "WHERE m.pid=f.id AND t.id=m.tid AND m.up=0".
              " AND portalNews='yes' AND descriptionTxt!=''".
              " AND displayPeriodStart<'$time'".
              " AND '$time'<displayPeriodEnd";
    if ($pids!=0 && !is_array($pids)) $query.=" AND m.pid=$pids";
    if ($pids!=0 && is_array($pids)) {
        for($i=0;isset($pids[$i]);$i++) {
            if ($i==0) $query.=" AND ( m.pid=".$pids[$i];
            else $query.=" OR m.pid=".$pids[$i];
            if (!isset($pids[$i+1])) $query.=" )";
        }
    }
    $query.=" ORDER BY PRIO ASC, m.creationtime DESC";
    $query.=" LIMIT $portalBlockSize";
    $m = new ForumMessage;
    $ret = $m->loadObjectsSQL($query,$list, TRUE);
    $noErr = $ret==ok || $ret==not_found_in_db;
    if ($ret!=ok) {
        return $ret;
    }    
    global $readAccessArr;
    $ret=readAccessForums();
    if( $ret ) {
        return $ret;
    } 
    hasAdminRights($isAdm);
    if( !$isAdm )   
    {
        $newList = array();
        for($i=0;isset($list[$i]);$i++)
        {
            if (isset($readAccessArr[$list[$i]->pid]))
            {
                $newList[] = $list[$i];
            }
        }
        $list=$newList;
    }
    return ok;    
}
function loadCurrentCategories(&$list,$pids=0)
{
    global $zorumuser,$activeForum,$zorumroll;
    if (!$activeForum) {
        $list = array();
        return ok;
    }
    $query="SELECT * FROM forum_zorum WHERE portalNews='yes'".
           " AND up=".(int)$activeForum->up;
    $m = new Forum;
    $ret = $m->loadObjectsSQL($query,$list, TRUE);
    $noErr = $ret==ok || $ret==not_found_in_db;
    if ($ret!=ok) 
    {
        return $ret;
    }    
    global $readAccessArr;
    $ret=readAccessForums();
    if( $ret ) {
        return $ret;
    } 
    hasAdminRights($isAdm);
    if( !$isAdm )   
    {
        $newList = array();
        for($i=0;isset($list[$i]);$i++)
        {
            if (isset($readAccessArr[$list[$i]->id]))
            {
                $newList[] = $list[$i];
            }
        }
        $list=$newList;
    }
    return ok;    
}
function loadParentCategories(&$list,$pids=0)
{
    global $zorumuser,$parentForum,$zorumroll;
    if (!$parentForum) {
        $list = array();
        return ok;
    }
    $query="SELECT * FROM forum_zorum WHERE portalNews='yes'".
           " AND up=".(int)$parentForum->up;
    $m = new Forum;
    $ret = $m->loadObjectsSQL($query,$list, TRUE);
    $noErr = $ret==ok || $ret==not_found_in_db;
    if ($ret!=ok) 
    {
        return $ret;
    }    
    global $readAccessArr;
    $ret=readAccessForums();
    if( $ret ) {
        return $ret;
    } 
    hasAdminRights($isAdm);
    if( !$isAdm )   
    {
        $newList = array();
        for($i=0;isset($list[$i]);$i++)
        {
            if (isset($readAccessArr[$list[$i]->id]))
            {
                $newList[] = $list[$i];
            }
        }
        $list=$newList;
    }
    return ok;    
}
function loadTopicsInCategory(&$list,$pid, $showAll=FALSE)
{
    global $zorumuser,$activeForum,$zorumroll;
    global $maxTopicNumInTopicList;
    $time = time();
    $query="SELECT * FROM forumtopic_zorum WHERE pid=$pid ".
           "ORDER BY creationtime DESC";
    if( !$showAll ) $query.=" LIMIT $maxTopicNumInTopicList";
    $m = new ForumTopic;
    $ret = $m->loadObjectsSQL($query,$list, TRUE);
    $noErr = $ret==ok || $ret==not_found_in_db;
    if ($ret!=ok) {
        return $ret;
    }    
    return ok;    
}
function loadSubCategories(&$list,$pids=0)
{
    global $zorumuser,$activeForum,$zorumroll;
    if (!$activeForum) $up=0;
    else $up=$activeForum->id;
    $query="SELECT * FROM forum_zorum WHERE portalNews='yes'".
           " AND up=".(int)$up;
    $m = new Forum;
    $ret = $m->loadObjectsSQL($query,$list, TRUE);
    $noErr = $ret==ok || $ret==not_found_in_db;
    if ($ret!=ok) {
        return $ret;
    }    
    global $readAccessArr;
    $ret=readAccessForums();
    if( $ret ) {
        return $ret;
    } 
    hasAdminRights($isAdm);
    if( !$isAdm )   
    {
        $newList = array();
        for($i=0;isset($list[$i]);$i++)
        {
            if (isset($readAccessArr[$list[$i]->id]))
            {
                $newList[] = $list[$i];
            }
        }
        $list=$newList;
    }
    return ok;    
}
function showMoreMessage(&$s)
{
    global $zorumroll, $zorumuser;
    global $forummessage_typeInfo;
    $query = "SELECT ".getAllColumns($forummessage_typeInfo, "m").
              "f.name AS forumname,viewnum,t.postnum AS postnum".
              ",poll,portalNews,f.wholeniceurl AS f_wholeniceurl,".
              " t.wholeniceurl AS t_wholeniceurl FROM ".
              "forummessage_zorum AS m, forum_zorum AS f,".
              " forumtopic_zorum AS t ".
              "WHERE m.pid=f.id AND t.id=m.tid".
              " AND m.id=$zorumroll->rollid";
    $m = new ForumMessage;
    $ret = $m->loadObjectsSQL($query,$list, TRUE);
    $noErr = $ret==ok || $ret==not_found_in_db;
    if ($ret!=ok) {
        return $ret;
    }    
    global $fatherForum, $fatherTopic;
    $ret = $list[0]->cacheFatherObjects("forum, topic");
    if ($ret!=ok) {
        return $ret;
    }    
    if( $fatherTopic->ownerId!=$zorumuser->id ) 
    {
        $fatherTopic->viewnum++;
        $ret=modify($fatherTopic);
        if ($ret!=ok) {
            return $ret;
        }  
    }   
    $list[0]->forumname=$fatherForum->name;
    $list[0]->viewnum=$fatherTopic->viewnum;
    $list[0]->postnum=$fatherTopic->postnum;
    $ret=showMessageList($list,$s,TRUE);
    return $ret;    
}
function showMessageList($list,&$s,$readmore=FALSE)
{
    global $zorumroll;
    global $portalNiceUrl;
    global $langTxt;
    global $beginUrl;
    $s="";
    foreach($list as $mess) {
        $footer="";
        $u=$mess->showListVal("creator",TRUE);
        $footer.=$langTxt["postedby"]." ".$u;
        $footer.=" - ";
        $footer.=showTimestamp($mess->creationtime);
        if ($mess->txt!="") {
            $footer.=" - ";
            if ($zorumroll->method!="readmore") {
               $url = $beginUrl.$mess->t_wholeniceurl;
               if ($portalNiceUrl=="yes" && $mess->t_wholeniceurl!="") {
                   $footer.="<a href='$url'"." class='listItem'>".
                            $langTxt["readmore"]."</a>";
               }
               else {
                   $tempRoll = $zorumroll;
                   $tempRoll->method = "readmore";
                   $tempRoll->rollid = $mess->id;
                   $footer.=$tempRoll->generAnchor($langTxt["readmore"],
                                                   "listItem");
               }
               $footer.=" - ";
            }
            $footer.=$mess->viewnum." ".$langTxt["reads"];
        }
        $footer.=" - ";
        $cnum=$mess->postnum-1;
        $tempRoll=$zorumroll;
        $tempRoll->scriptname = "z_forummessage_show.php";
        $tempRoll->class="forummessage";
        $tempRoll->method="showhtmllist";
        $tempRoll->rollid="$mess->pid,$mess->tid";  
        $tempRoll->rangeoffset = $tempRoll->offset = 0;
        $footer.="$cnum ";
        $footer.=$tempRoll->generAnchor($langTxt["comments"],
                                        "listItem");
        $txt="";
        $txt.=$mess->descriptionTxt;
        if ($readmore) $txt.="\n\n".$mess->txt;
        $ret=applyUbbDecoding($mess, $txt);
        if ($ret) {
            return $ret;
        }
        $tempRoll = $zorumroll;
        $tempRoll->method = "catnews";
        $tempRoll->rollid = $mess->pid;
        if ($portalNiceUrl=="yes" && $mess->f_wholeniceurl!="") {
            $url = $beginUrl.$mess->f_wholeniceurl;
            $head="<a href='$url' class='listItem'>".
                   $mess->forumname."</a>";
        }
        else $head=$tempRoll->generAnchor($mess->forumname,"listItem");
        $head.="&nbsp;-&nbsp;".$mess->subject;
        $s1="";
        showPortalBox($s1,$head,$txt,$footer);
        $s.=$s1;
        $s.="<p>";
    }
    return ok;
}
function showLatestNews(&$s)
{
    $ret=loadLatestNews($news);
    if ($ret==not_found_in_db) {
        return ok;
    }
    elseif ($ret) {
        return $ret;
    }
    $ret=showMessageList($news,$s);
    return $ret;    
}
function showCategoryNews(&$s)
{
    global $zorumroll;
    global $forumsInPortal;
    global $activeForum;
    if ($zorumroll->rollid) {
        $ret=$activeForum->cacheChildrenObjects();
        if( $ret!=ok ) {
            return $ret;
        }
        global $childrenForumList;
        $pids[] = $activeForum->id;
        foreach($childrenForumList as $f) {
            $pids[]=$f->id;
        }
        $ret=loadLatestNews($news,$pids);
    }
    else {
        if ($forumsInPortal=="") {
            $ret=loadLatestNews($news);
        }
        else {
            $pids=split(", *",$forumsInPortal);
            $ret=loadLatestNews($news,$pids);
        }
    }
    if ($ret==not_found_in_db) {
        $ret = showTopicsInCategory($s1);
        if ($ret) {
            return $ret;
        }
        if( $s1 ) $s.="<p>$s1";
        return ok;
    }
    elseif ($ret) {
        return $ret;
    }
    $ret=showMessageList($news,$s);
    if ($ret) {
        return $ret;
    }
    if( $zorumroll->rollid )
    {
        $ret = showTopicsInCategory($s1);
        if ($ret) {
            return $ret;
        }
        if( $s1 ) $s.="<p>$s1";
    }
    return $ret;    
}
function showQuickHelpBox(&$s)
{
    global $langTxt,$zorumroll;
    $tempRoll = $zorumroll;
    $tempRoll->method = "gettingman";
    $link=$tempRoll->generAnchor($langTxt["helpgetting2"],"listItem");
    $s=$langTxt["helpgetting1"].$link.$langTxt["helpgetting3"];
    return ok;
}
function showPortalGettingStarted(&$s)
{
    global $langTxt;
    $s=$langTxt["gettingman"];
}
function showSubCategories(&$s)
{
    global $zorumroll,$activeForum, $langTxt;
    global $portalNiceUrl,$beginUrl;
    $s="";
    $ret=loadSubCategories($cats);
    if ($ret==not_found_in_db) {
        return ok;
    }
    if ($ret) {
        return $ret;
    }
    $menuList=array();
    $tempRoll = $zorumroll;
    $tempRoll->method = "catnews";
    if (!isset($cats[0])) return ok;
    foreach($cats as $cat) {
        $tempRoll->rollid = $cat->id;
        if ($portalNiceUrl=="yes" && $cat->niceurl!="") {
            $url = $beginUrl.$cat->wholeniceurl;
            $menuList[]="<a href='".$url.
                        "' class='listItem'>".$cat->name."</a>";
        }
        else $menuList[]=$tempRoll->generAnchor($cat->name,"listItem");
    }
    if( $activeForum )
    {
        showPortalBox($s,$langTxt["boxTitle_subcategories"],$menuList);
    }
    else
    {
        showPortalBox($s,$langTxt["boxTitle_currentcategories"],$menuList);
    }    
    return ok;
}
function showParentCategories(&$s)
{
    global $zorumroll, $langTxt;
    global $portalNiceUrl,$beginUrl;
    $s="";
    $ret=loadParentCategories($cats);
    if ($ret==not_found_in_db) {
        return ok;
    }
    elseif ($ret) {
        return $ret;
    }
    $menuList=array();
    $tempRoll = $zorumroll;
    $tempRoll->method = "catnews";
    if (!isset($cats[0])) return ok;
    foreach($cats as $cat) {
        $tempRoll->rollid = $cat->id;
        if ($portalNiceUrl=="yes" && $cat->niceurl!="") {
            $url = $beginUrl.$cat->wholeniceurl;
            $menuList[]="<a href='".$url.
                        "' class='listItem'>".$cat->name."</a>";
        }
        else $menuList[]=$tempRoll->generAnchor($cat->name,"listItem");
    }
    showPortalBox($s,$langTxt["boxTitle_parentcategories"],$menuList);
    return ok;
}
function showCurrentCategories(&$s)
{
    global $zorumroll,$activeForum, $langTxt;
    global $portalNiceUrl,$beginUrl;
    $s="";
    $ret=loadCurrentCategories($cats);
    if ($ret==not_found_in_db) {
        return ok;
    }
    elseif ($ret) {
        return $ret;
    }
    $menuList=array();
    $tempRoll = $zorumroll;
    $tempRoll->method = "catnews";
    if (!isset($cats[0])) return ok;
    $actItem=-1;
    $i=0;
    foreach($cats as $cat) {
        if ($activeForum && $cat->id==$activeForum->id) $actItem=$i;
        $tempRoll->rollid = $cat->id;
        if ($portalNiceUrl=="yes" && $cat->niceurl!="") {
            $url = $beginUrl.$cat->wholeniceurl;
            $menuList[]="<a href='".$url.
                        "' class='listItem'>".$cat->name."</a>";
        }
        else $menuList[]=$tempRoll->generAnchor($cat->name,"listItem");
        $i++;
    }
    showPortalBox($s,$langTxt["boxTitle_currentcategories"],$menuList,"",$actItem);
    return ok;
}
function showPoll(&$s, $pollId)
{
    global $langTxt;
    global $zorumuser;
    $s="";
    $subscribe = new Subscribe;
    $subscribe->classId = $pollId;
    $subscribe->type = poll_vote;
    $subscribe->userId = $zorumuser->id;
    $ret = load($subscribe, array("classId", "type", "userId"));
    $notYetVoted = ($ret==not_found_in_db);
    $poll = new Poll;
    $poll->id = $pollId;
    $ret=$poll->load();
    if( $ret )
    {
        return ok;
    }
    $ret = $poll->hasObjectRights($hasRight, Priv_insert, FALSE);
    if ($ret!=ok) {
        return $ret;
    }
    if( $hasRight && $notYetVoted )
    {
        $ret = $poll->getPollQuestion($s);
    }
    else
    {
        $ret = $poll->getPollResult($s);
    }
    if( $ret!=ok ){
        $s = sprintf($langTxt["noSuchPoll"], $pollId);
        $ret = ok;
    }
    return ok;
}
function showTopicsInCategory(&$s, $showAll=FALSE)
{
    global $zorumroll,$activeForum;
    global $langTxt;
    global $maxTopicNumInTopicList;
    global $portalNiceUrl,$beginUrl;
    $s="";
    if ($zorumroll->rollid) $pid=$zorumroll->rollid;
    else 
    {
        return ok;
    }
    $ret=loadTopicsInCategory($topics,$pid,$showAll);
    if ($ret==not_found_in_db) {
        return ok;
    }
    elseif ($ret) {
        return $ret;
    }
    $menuList=array();
    $tempRoll = $zorumroll;
    $tempRoll->method = "readmore";
    $actItem=-1;
    foreach($topics as $topic) {
        if ($portalNiceUrl=="yes" && $topic->niceurl!="") {
            $url = $beginUrl.$topic->wholeniceurl;
            $menuList[]="<a href='$url' class='listItem'>".
                        $topic->subject."</a>";
        }
        else {
            $firstMessage = new ForumMessage;
            $firstMessage->tid = $topic->id;    
            $firstMessage->pid = $topic->pid;    
            $firstMessage->up = 0;    
            $ret = load( $firstMessage, array("tid", "pid", "up") );
            if ($ret!=ok) {
                return $ret;
            }
            $tempRoll->rollid = $firstMessage->id;
            $menuList[]=$tempRoll->generAnchor($topic->subject,
                                               "listItem");
        }
    }
    $footer = "";
    if( !$showAll && count($topics)==$maxTopicNumInTopicList)
    {
        $tempRoll = $zorumroll;
        $tempRoll->method = "showtopicsincategory";        
        $footer=$tempRoll->generAnchor($langTxt["showAllPagesInCategory"],"listItem");
    }
    showPortalBox($s,$langTxt["pagesInCategory"],$menuList,$footer);
    return ok;
}
function showSpecFunctions(&$s)
{
    global $langTxt;
    global $activeForum;
    global $zorumroll;
    $tempRoll = new Roll;
    $tempRoll->scriptname = "portal.php";
    $menuList[]=$tempRoll->generAnchor($langTxt["home"],"listItem");
    goForward( $tempRoll, "mainmenu_3" );
    $tempRoll->menu=3;
    $menuList[]=$tempRoll->generAnchor($langTxt["mainmenu_3"],"listItem");
    $tempRoll = new Roll;
    $tempRoll->scriptname = "forum.php";
    $menuList[]=$tempRoll->generAnchor($langTxt["forumname"],"listItem");
    $tempRoll = new Roll;
    $tempRoll->scriptname = "z_settings_form.php";
    $tempRoll->class = "settings";
    $tempRoll->method = "modifyportalsettings_form";
    saveInFrom($tempRoll);
    $menuList[]=$tempRoll->generAnchor($langTxt["settings_modifyportalsettings_form"],"listItem");
    hasAdminRights($isAdm);
    if( $isAdm )
    {
        $tempRoll = new Roll;
        $tempRoll->scriptname = "z_forum_form.php";
        $tempRoll->class = "forum";
        $tempRoll->method = "createchildforum_form";
        $tempRoll->up = $activeForum ? $activeForum->id : 0;
        $tempRoll->portalNews = "yes";
        saveInFrom($tempRoll);
        $menuList[]=$tempRoll->generAnchor($langTxt["createCategory"],"listItem");
        $tempRoll = new Roll;
        $tempRoll->scriptname = "z_box_show.php";
        $tempRoll->class = "box";
        $tempRoll->method = "showhtmllist";
        $menuList[]=$tempRoll->generAnchor($langTxt["boxOrganizer"],"listItem");
        $tempRoll = new Roll;
        $tempRoll->scriptname = "z_settings_form.php";
        $tempRoll->class = "settings";
        $tempRoll->method = "modifyglobalportalsettings_form";
        saveInFrom($tempRoll);
        $menuList[]=$tempRoll->generAnchor($langTxt["customizeGlobalPortalSettings"],"listItem");
        $tempRoll = new Roll;
        $tempRoll->scriptname = "z_stat.php";
        $tempRoll->rollid = 0;
        $tempRoll->method = "stat";
        $menuList[]=$tempRoll->generAnchor($langTxt["stati"],"listItem");
    }
    showPortalBox($s,$langTxt["boxTitle_specfunctions"],$menuList);
    return ok;
}
function showWhoIsOnline(&$s)
{
    global $zorumroll;
    showStatusLine($s1);
    $ret = showUsersOnlineRow($s2);
    if ($ret!=ok) {
        return $ret;
    }
    $s=$s1."<p>".$s2;
    return ok;
}
function showPortalLoginMenu(&$s)
{
    global $zorumauthlevel, $zorumrecognised;
    global $necessaryAuthLevel;
    global $langTxt;
    $menuList=array();
    goForward( $tempRoll, "register" );
    $menuList[]=$tempRoll->generAnchor($langTxt["register"],"listItem");
    if($zorumauthlevel<Loginlib_HighLevel)
    {
        goForward( $tempRoll, "login" );
        if( $zorumrecognised ) {
            $menuList[]=$tempRoll->generAnchor(
                $langTxt["lowLevelLoginDifferrent"],"listItem");
        }
        else
        {
            if( $necessaryAuthLevel==Loginlib_HighLevel ) {
                $menuList[]=$tempRoll->generAnchor(
                    $langTxt["secureHighLevelLogin"],"listItem");
            }
            else
            {
                $menuList[]=$tempRoll->generAnchor($langTxt["login"],"listItem");
            }
        }
    }
    if( Loginlib_GuestLevel<$zorumauthlevel && 
        $zorumauthlevel<Loginlib_HighLevel)
    {
        goForward( $tempRoll, "logout" );
        $tempRoll->fromscriptname = "portal.php";
        $menuList[]=$tempRoll->generAnchor($langTxt["logout"],"listItem");
    }
    showPortalBox($s,$langTxt["boxTitle_portalloginmenu"],$menuList);
    return ok;
}
function loadActiveObjects()
{
    global $activeForum,$parentForum,$activeMessage,$zorumroll;
    global $SCRIPT_NAME,$beginUrl,$portalNiceUrl,$forummessage_typeInfo;
    $activeForum = $parentForum = $activeMessage = 0;
    if (($zorumroll->method=="catnews" || 
         $zorumroll->method=="showtopicsincategory") && 
         $zorumroll->rollid)
    {
        $activeForum = new Forum;
        $activeForum->id=$zorumroll->rollid;
        $ret=load($activeForum);
        if ($ret!=ok) {
            return $ret;
        }
        if ($portalNiceUrl=="yes" && $activeForum->wholeniceurl!="") {
            $beginUrl=substr($SCRIPT_NAME,0,strpos($SCRIPT_NAME,
                            $activeForum->wholeniceurl));
        }
        else {
           $beginUrl=substr($SCRIPT_NAME,0,strrpos($SCRIPT_NAME,"/")+1);
        }
    }
    elseif ($zorumroll->method=="readmore") {
        $query = "SELECT ".getAllColumns($forummessage_typeInfo, "m").
                  "f.name AS forumname,viewnum,t.postnum AS postnum".
                  ",poll,portalNews,f.wholeniceurl AS f_wholeniceurl,".
                  " t.wholeniceurl AS t_wholeniceurl FROM ".
                  "forummessage_zorum AS m, forum_zorum AS f,".
                  " forumtopic_zorum AS t ".
                  "WHERE m.pid=f.id AND t.id=m.tid".
                  " AND m.id=$zorumroll->rollid";
        $m = new ForumMessage;
        $ret = $m->loadObjectsSQL($query,$list, TRUE);
        $noErr = $ret==ok || $ret==not_found_in_db;
        if ($ret!=ok) {
            return $ret;
        }
        $activeMessage = $list[0];
        /*
        $activeMessage = new ForumMessage;
        $activeMessage->id=$zorumroll->rollid;
        $ret=load($activeMessage);
        if ($ret!=ok) {
            return $ret;
        }
        */
        $activeForum = new Forum;
        $activeForum->id=$activeMessage->pid;
        $ret=load($activeForum);
        if ($ret!=ok) {
            return $ret;
        }
        if ($portalNiceUrl=="yes"&&$activeMessage->t_wholeniceurl!="") {
            $beginUrl=substr($SCRIPT_NAME,0,strpos($SCRIPT_NAME,
                            $activeMessage->t_wholeniceurl));
        }
        else {
           $beginUrl=substr($SCRIPT_NAME,0,strrpos($SCRIPT_NAME,"/")+1);
        }
    }
    else {
        $beginUrl=substr($SCRIPT_NAME,0,strrpos($SCRIPT_NAME,"/")+1);
    }
    if ( $activeForum && $activeForum->up) {
        $parentForum = new Forum;
        $parentForum->id=$activeForum->up;
        $ret=load($parentForum);
        if ($ret!=ok) {
            return $ret;
        }
    }    
    return ok;
}
function showPortalHeader(&$s, $alignment)
{
    global $activeForum;
    global $dotDot;
    $s="";
    $id =  $activeForum ? $activeForum->id : 0;
    $boxes = new Box;
    $query="SELECT * FROM box_zorum WHERE ".
           "(forumId='$id' OR forumId='-1') AND alignment='$alignment'".
           " AND status='enabled' ORDER BY idx ASC";
    $ret = loadObjectsSql( $boxes, $query, $boxes );
    if ($ret==not_found_in_db) {
        return ok;
    }
    elseif ($ret) {
        return $ret;
    }
    $first = TRUE;
    $s.="<table width='100%' border='0'>";
    foreach( $boxes as $box )
    {
        $content="";
        if( $box->contentType=="Php4" || $box->contentType=="Poll") 
        {
            $ret = ok;
            eval($box->content); 
            if ($ret) {
                return $ret;
            }
        }    
        else $content = $box->content;
        if( $box->style=="framed" )
        {
            showPortalBox($s1,$box->title,$content);
        }
        else $s1=$content;
        if( $s1 )
        {
            $s.="<tr><td>";
            if( !$first ) {
                $s.="<img src='$dotDot/i/b.gif' height='10'>\n";
            }
            $s.=$s1;
            $s.="</td></tr>\n";
            $first = FALSE;
        }
    }    
    $s.="</table>";
    return ok;
}
function showBlankPage(&$s)
{
    global $langTxt;
    showPortalBox($s,$langTxt["blankPage"],"");
}
function showPortal($leftHeader, $result, $rightHeader)
{
    global $portalLeftWidth,$portalLeftBgImg,$portalLeftBgCol;
    global $portalMiddleWidth,$portalMiddleBgImg,$portalMiddleBgCol;
    global $portalRightWidth,$portalRightBgImg,$portalRightBgCol;
    $s="";
    $s.="<table border='0' width='100%'><tr>";
    if( $leftHeader )
    {
        if (!isset($portalLeftWidth)) $portalLeftWidth="160";
        $s.="<td valign='top' width='$portalLeftWidth'";
        if (isset($portalLeftBgImg)) {
            $s.=" background='$portalLeftBgImg'";
        }
        if (isset($portalLeftBgCol)) {
            $s.=" bgcolor='$portalLeftBgCol'";
        }
        $s.=">$leftHeader</td>\n";
    }    
    if (!isset($portalMiddleWidth)) $portalMiddleWidth="100%";
    /*
    $s.="<td valign='top' width='$portalMiddleWidth'>";
    $s.="<table width='100%' border='0'><tr><td";
    */
    $s.="<td valign='top'>";
    $s.="<table width='$portalMiddleWidth' border='0'><tr><td";    
    if (isset($portalMiddleBgImg)) {
        $s.=" background='$portalMiddleBgImg'";
    }
    if (isset($portalMiddleBgCol)) {
        $s.=" bgcolor='$portalMiddleBgCol'";
    }
    $s.=">";
    if( $result=="" )
    {
        showBlankPage($result);
    }
    $s.=$result;
    $s.="</td></tr></table>\n";
    $s.="</td>\n";
    if( $rightHeader )
    {
        if (!isset($portalRightWidth)) $portalRightWidth="160";
        $s.="<td valign='top' width='$portalRightWidth' align='right'";
        if (isset($portalRightBgImg)) {
            $s.=" background='$portalRightBgImg'";
        }
        if (isset($portalRightBgCol)) {
            $s.=" bgcolor='$portalRightBgCol'";
        }
        $s.=">$rightHeader</td>\n";
    }
    $s.="</tr></table>\n";
    return $s;
}
?>
