<?php
define( "Priv_load", 1 );
define( "Priv_modify", 2 );
define( "Priv_delete", 4 );
define( "Priv_create", 8 );
define( "Priv_insert", 16 );
define( "Priv_MaxRight", 16+8+4+2+1 );
define( "Priv_RightNum", 5 );
function hasAdminRights( &$hasRight, $base="", $method="" )
{
    global $zorumuser;
    global $zorumrecognised;
    $hasRight = ($zorumrecognised && $zorumuser->isAdm=="yes");    
    return ok;
}
function hasGeneralRights($base, &$rights)
{
    global $generalRight;
    $rights = array();
    $ret = $base->hasObjectRights($hasRight, Priv_load);
    if( $ret ) {
        return $ret;
    }    
    if( $generalRight ) $rights[Priv_load] = $hasRight;
    $ret = $base->hasObjectRights($hasRight, Priv_create);
    if( $ret ) {
        return $ret;
    }    
    if( $generalRight ) $rights[Priv_create] = $hasRight;
    $ret = $base->hasObjectRights($hasRight, Priv_modify);
    if( $ret ) {
        return $ret;
    }    
    if( $generalRight ) $rights[Priv_modify] = $hasRight;
    $ret = $base->hasObjectRights($hasRight, Priv_delete);
    if( $ret==permission_denied ) {
        return $ret;
    }    
    if( $generalRight ) $rights[Priv_delete] = $hasRight;
    return ok;
}
function privilegeLoad(&$base, $whereFields="",$whatFields="*",$overrulePrivilege=FALSE) 
{
    global $errTxt;
    global $zorumuser;
    $ret = load( $base, $whereFields, $whatFields );
    if ($ret==not_found_in_db) {
        return $ret;
    }    
    if( $ret )
    {
        return $ret;
    }
    if( $overrulePrivilege )
    {
        return ok;
    }
    $ret = $base->hasObjectRights( $hasRight, Priv_load, TRUE );
    return $ret;
}
function privilegeCreate(&$base, $overrulePrivilege=FALSE)
{
    global $zorumuser;
    global $errTxt;
    global $submit;
    global $whatHappened, $infoText;
    global $langTxt;
    global $zorumroll;
    $whatHappened = "form_submitted";
    if( $submit==$langTxt["cancel"] )
    {   
        $infoText[] = $langTxt["operation_cancelled"];
        return ok;
    } 
    $className = $base->getClass();
    if( $overrulePrivilege)
    {
        $ret = create($base);
        if( !$ret && $whatHappened!="invalid_form" )
        {
            $infoText[] = sprintf($langTxt["created"], 
                                  $langTxt[$className]);
        }
        return $ret;
    }
    $ret = $base->hasObjectRights( $hasRight, Priv_create, TRUE );
    if( $ret )
    {
        return $ret;
    }
    $base->ownerId = $zorumuser->id;
    $ret = create($base);
    if( !$ret && $whatHappened!="invalid_form" )
    {
        $infoText[] = sprintf($langTxt["created"], 
                              $langTxt[$className]);
    }
    return $ret;
}
function privilegeModify( $base, $whereFields="",$overrulePrivilege=FALSE )
{
    global $errTxt;
    global $whatHappened, $infoText;
    global $submit;
    global $langTxt;
    global $zorumroll;
    global $zorumuser;
    $whatHappened = "form_submitted";
    if( $submit==$langTxt["cancel"] )
    {   
        $infoText[] = $langTxt["operation_cancelled"];
        return ok;
    } 
    $className = $base->getClass();
    if( $overrulePrivilege)
    {
        $ret = modify( $base, $whereFields);
        if( !$ret && $whatHappened!="invalid_form" )
        {
            $infoText[] = sprintf($langTxt["modified"], 
                                  $langTxt[$className]);
        }
        return $ret;
    }
    $class = get_class($base);
    $oldBase = new $class;
    $oldBase->copy( $base, $whereFields );
    $ret = load( $oldBase, $whereFields );
    if( $ret )
    {
        return $ret;
    }
    $ret = $oldBase->hasObjectRights( $hasRight, Priv_modify, TRUE );
    if( $ret )
    {
        return $ret;
    }
    if( $zorumuser->isAdm=="no" )
    {
        $typ = $base->getTypeInfo();
        $modifyableAttributes = array();
        foreach( $typ["attributes"] as $attribute=>$attrInfo )
        {
            if( !in_array("private",$attrInfo) )
            $modifyableAttributes[] = $attribute;
        }
        $oldBase->compare( $base, $changedAttributes );
        $difference = array_diff($changedAttributes, $modifyableAttributes);
        if( sizeof($difference) )
        {
            global $infoText;
            global $errTxt;
            $txt = $errTxt[permission_denied];
            $infoText[] = $txt;
            return permission_denied;
        }
    }
    $ret = modify( $base, $whereFields);
    if( !$ret && $whatHappened!="invalid_form" )
    {
        $infoText[] = sprintf($langTxt["modified"], 
                              $langTxt[$className]);
    }
    return $ret;
}
function privilegeDelete( &$base, $whereFields="",$overrulePrivilege=FALSE )
{
    global $errTxt;
    global $langTxt;
    global $submit;
    global $whatHappened, $infoText;
    global $zorumuser;
    $whatHappened = "form_submitted";
    if( $submit==$langTxt["no"] )
    {   
        $infoText[] = $langTxt["operation_cancelled"];
        return ok;
    } 
    $className = $base->getClass();
    $ret = load( $base, $whereFields );
    if( $ret==not_found_in_db ) {
        return $ret;
    }
    if( $ret )
    {
        return $ret;
    }
    if( $overrulePrivilege )
    {
        $ret = delete( $base, $whereFields);
        return $ret;
    }
    $ret = $base->hasObjectRights( $hasRight, Priv_delete, TRUE );
    if( $ret )
    {
        return $ret;
    }
    $ret = delete( $base, $whereFields );
    if ($ret!=ok && $ret!=not_found_in_db) {
        return $ret;
    }
    $infoText[] = sprintf($langTxt["deleted"], 
                          $langTxt[$className]);
    return $ret;
}
?>
