<?php
$stylesheet_typeInfo = 
    array(
        "attributes"=>array(   
            "id"=>array(
                "type"=>"INT",
                "min" =>"0",
                "unsigned",
                "not null",
                "auto increment",
                "form hidden"
            ),
            "name"=>array(
                "type"=>"VARCHAR",
                "max" =>"255",
                "min" =>"1",
                "not null",
                "list",
                "sorta"
            ),
            "type"=>array(
                "type"=>"ENUM",
                "values"=>array( "font", "color" ),
                "form hidden",
                "not null"
            ),
            "userLink"=>array(
                "type"=>"VARCHAR",
                "max" =>"255",
                "not null",
                "style"
            ),
            "forumDescription"=>array(
                "type"=>"VARCHAR",
                "max" =>"255",
                "not null",
                "style"
            ),
            "forumAccess"=>array(
                "type"=>"VARCHAR",
                "max" =>"255",
                "not null",
                "style"
            ),
            "explanationText"=>array(
                "type"=>"VARCHAR",
                "max" =>"255",
                "not null",
                "style"
            ),
            "forumStatistics"=>array(
                "type"=>"VARCHAR",
                "max" =>"255",
                "not null",
                "style"
            ),
            "loginMenu"=>array(
                "type"=>"VARCHAR",
                "max" =>"255",
                "not null",
                "style"
            ),
            "greetingMessage"=>array(
                "type"=>"VARCHAR",
                "max" =>"255",
                "not null",
                "style"
            ),
            "mainMenu"=>array(
                "type"=>"VARCHAR",
                "max" =>"255",
                "not null",
                "style"
            ),
            "userMenu"=>array(
                "type"=>"VARCHAR",
                "max" =>"255",
                "not null",
                "style"
            ),
            "messageLine"=>array(
                "type"=>"VARCHAR",
                "max" =>"255",
                "not null",
                "style"
            ),
            "navBar"=>array(
                "type"=>"VARCHAR",
                "max" =>"255",
                "not null",
                "style"
            ),
            "rangeSelector"=>array(
                "type"=>"VARCHAR",
                "max" =>"255",
                "not null",
                "style"
            ),
            "header"=>array(
                "type"=>"VARCHAR",
                "max" =>"255",
                "not null",
                "style"
            ),
            "sorter"=>array(
                "type"=>"VARCHAR",
                "max" =>"255",
                "not null",
                "style"
            ),
            "listItemTitle"=>array(
                "type"=>"VARCHAR",
                "max" =>"255",
                "not null",
                "style"
            ),
            "listItem"=>array(
                "type"=>"VARCHAR",
                "max" =>"255",
                "not null",
                "style"
            ),
            "messageText"=>array(
                "type"=>"VARCHAR",
                "max" =>"255",
                "not null",
                "style"
            ),
            "command"=>array(
                "type"=>"VARCHAR",
                "max" =>"255",
                "not null",
                "style"
            ),
            "messageHeader"=>array(
                "type"=>"VARCHAR",
                "max" =>"255",
                "not null",
                "style"
            ),
            "newMessageHeader"=>array(
                "type"=>"VARCHAR",
                "max" =>"255",
                "not null",
                "style"
            ),
            "explanationBar"=>array(
                "type"=>"VARCHAR",
                "max" =>"255",
                "not null",
                "style"
            ),
            "jumperTool"=>array(
                "type"=>"VARCHAR",
                "max" =>"255",
                "not null",
                "style"
            ),
            "allTimes"=>array(
                "type"=>"VARCHAR",
                "max" =>"255",
                "not null",
                "style"
            ),
            "currentTime"=>array(
                "type"=>"VARCHAR",
                "max" =>"255",
                "not null",
                "style"
            ),
            "userStatistics"=>array(
                "type"=>"VARCHAR",
                "max" =>"255",
                "not null",
                "style"
            ),
            "postingInfo"=>array(
                "type"=>"VARCHAR",
                "max" =>"255",
                "not null",
                "style"
            ),
            "portalPoll"=>array(
                "type"=>"VARCHAR",
                "max" =>"255",
                "not null",
                "style"
            ),
            "visibility"=>array(
                "type"  =>"ENUM",
                "values"=>array( "private", "public" ),
                "default"=>"private",
                "not null"
            ),
            "ownerId"=>array(
                "type"=>"INT",
                "unsigned",
                "form invisible",
                "private"
            )       
        ),
        "primary_key"=>array( "id"),
        "unique_keys"=>array( "name, type" ),
        "tableName"=>"stylesheet_zorum",
        "sorta"=>"name"
    );
class StyleSheet extends Object
{
    function hasObjectRights(&$hasRight, $method, $giveError=FALSE)
    {
        global $zorumrecognised, $zorumuser, $zorumauthlevel;
        if( $zorumauthlevel==Loginlib_NewUser )
        {
            $hasRight=FALSE;
        }
        elseif( $method==Priv_delete )
        {
            $hasRight=FALSE;
        }
        elseif( $method==Priv_load && ($this->ownerId==$zorumuser->id ||
                $this->visibility=="public" || $zorumrecognised &&
                $zorumuser->isAdm=="yes") )
        {
            $hasRight=TRUE;
        }        
        if( !$zorumrecognised && $zorumauthlevel!=Loginlib_GuestLevel )
        {
            $hasRight=FALSE;
        }
        elseif( $method==Priv_create )
        {
            $hasRight=TRUE;
        }
        elseif( $this->ownerId==$zorumuser->id || $zorumrecognised &&
                $zorumuser->isAdm=="yes")
        {
            $hasRight=TRUE;
        }
        else
        {
            $hasRight=FALSE;
        }
        if( !$hasRight && $giveError )
        {
            global $infoText;
            global $errTxt;
            $txt = $errTxt[permission_denied];
            $infoText[] = $txt;
            return permission_denied;
        }
        return ok;
    }
    function showModifyLink(&$s, $type)
    {
        return stylesheet_showModifyLink($this, $s, $type);
    }
    function createForm(&$s)
    {
        return stylesheet_createForm($this, $s);
    }
    function createFormInvalid(&$s)
    {
        $ret = $this->createForm($s);
        return $ret;
    }
    function create()
    {
        return stylesheet_create($this);
    }
    function modifyForm(&$s)
    {
        return stylesheet_modifyForm($this, $s);
    }
} 
function insertSpanClass($s, $spanCl)
{
    $search = "'(^|>)(\s*[^\s<][^<]*)(<|$)'";  
    $replace = "\\1<span class='$spanCl'>\\2</span>\\3";
    $result = preg_replace ($search, $replace, $s);
    return $result;
}
function insertTdClass($s, $tdCl)
{
    $search = "<td";  
    $replace = "<td class='$tdCl'";
    $result = str_replace ($search, $replace, $s);
    return $result;
}
?>
