<?php
$user_typeInfo =  
    array(
        "attributes"=>array(   
            "id"=>array(
                "type"=>"INT",
                "min" =>"1",
                "unsigned",
                "not null",
                "form hidden"
            ),
            "name"=>array(
                "type"=>"VARCHAR",
                "max" =>"32",
                "not null",
                "list",
                "sorta",
                "readonly",
                "private"
            ),
            "email"=>array(
                "type"=>"VARCHAR",
                "max" =>"64",
                "not null",
                "list",
                "sorta"
            ),
            "password"=>array(
                "type"=>"VARCHAR",
                "max" =>"32",
                "not null",
                "password"
            ),
            "passwordLink"=>array(
                "type"=>"VARCHAR",
                "button",
                "no column"
            ),
            "newPassword"=>array(
                "type"=>"VARCHAR",
                "max" =>"32",
                "password",
                "form hidden",
                "not null"
            ),
            "passwordCopy"=>array(
                "type"=>"VARCHAR",
                "max" =>"32",
                "not null",
                "password",
                "no column"
            ),
            "rememberPassword"=>array(
                "type"  =>"ENUM",
                "values"=>array( "yes", "no" ),
                "not null",
                "no column"
            ),
            "showEmail"=>array(
                "type"  =>"ENUM",
                "values"=>array( "yes", "no" ),
                "not null",
                "default"=>"yes",
                "centered"
            ),
            "homepage"=>array(
                "type"=>"VARCHAR",
                "max" =>"64",
                "not null"
            ),
            "icqNumber"=>array(
                "type"=>"VARCHAR",
                "max" =>"32",
                "not null"
            ),
            "aolHandle"=>array(
                "type"=>"VARCHAR",
                "max" =>"32",
                "not null"
            ),
            "yahooHandle"=>array(
                "type"=>"VARCHAR",
                "max" =>"32",
                "not null"
            ),
            "gender"=>array(
                "type"  =>"ENUM",
                "values"=>array( "female", "male", "not yet defined" ),
                "not null",
                "default"=>"not yet defined"
            ),            
            "signature"=>array(
                "type"=>"TEXT",
                "rows" => 10,
                "cols" => 50,
                "not null"
            ),            
            "notes"=>array(
                "type"=>"TEXT",
                "rows" => 10,
                "cols" => 50,
                "not null"
            ),
            "isAdm"=>array(
                "type"  =>"ENUM",
                "values"=>array( "yes", "no" ),
                "default"=>"no",
                "form invisible",
                "private"
            ),
            "isMod"=>array(
                "type"  =>"ENUM",
                "values"=>array( "yes", "no" ),
                "default"=>"no",
                "form invisible",
                "private"
            ),
            "creationtime"=>array(
                "type"=>"INT",
                "form invisible",
                "list",
                "sorta",
                "private"
            ),
            "lastClickTime"=>array(
                "type"=>"INT",
                "form invisible",
                "list",
                "sortd",
                "private"
            ),
            "logoutTime"=>array(
                "type"=>"INT",
                "form invisible",
                "private"
            ),
            "postnum"=>array(
                "type"=>"INT",
                "min" =>"0",
                "default"=>"0",
                "unsigned",
                "list",
                "form invisible",
                "sorta",
                "private"
            ),            
            "ratenum"=>array(
                "type"=>"INT",
                "default"=>"0",
                "form invisible",
                "private"
            ),            
            "rateavg"=>array(
                "type"=>"FLOAT(2,1)",
                "default"=>"0",
                "form invisible",
                "private"
            ),            
            "rate"=>array(
                "type"=>"FLOAT(2,1)",
                "default"=>"0",
                "list",
                "sorta",
                "no column",
                "private"
            ),            
            "ownerId"=>array(
                "type"=>"INT",
                "unsigned",
                "form invisible",
                "private"
            )
        ),
        "primary_key"=>"id",
        "unique_keys"=>"name",
        "tableName"=>"user_zorum"
    );
class User extends Object
{
    function hasObjectRights(&$hasRight, $method, $giveError=FALSE)
    {
        global $zorumrecognised, $zorumauthlevel, $zorumuser;
        global $generalRight;
        $isAdm = ($zorumrecognised && $zorumuser->isAdm=="yes");    
        $generalRight = FALSE;
        if( $method==Priv_delete && $isAdm) 
        {
            $hasRight=TRUE;
            $generalRight = TRUE;
        }    
        elseif($method==Priv_delete &&
               isset($this->ownerId) && $this->ownerId==$zorumuser->id)
        {
            $hasRight=TRUE;
            $generalRight = FALSE;
        }    
        elseif( $method==Priv_load )
        {
            $hasRight=TRUE;
            $generalRight = TRUE;
        }    
        elseif( $method==Priv_create )
        {
            $hasRight=TRUE;
            $generalRight = TRUE;
        }
        else if( !$zorumrecognised  )
        {
            $hasRight=FALSE;
            $generalRight = TRUE;
        }
        elseif( $isAdm ) 
        {
            $hasRight=TRUE;
            $generalRight = TRUE;
        }
        elseif( isset($this->ownerId) && $this->ownerId==$zorumuser->id) 
        {
            $hasRight=TRUE;
            $generalRight = FALSE;
        }
        else
        {
            $hasRight=FALSE;
            $generalRight = FALSE;
        }
        if( !$hasRight && $giveError )
        {
            global $infoText;
            global $errTxt;
            $txt = $errTxt[permission_denied];
            $infoText[] = $txt;
            return permission_denied;
        }
        return ok;
    }
    function delete($overrulePrivilege=FALSE)
    {
        return user_delete($this,$overrulePrivilege);
    }
    function load($whereFields="",$whatFields="*") 
    {
        global $errTxt;
        global $zorumuser;
        $ret = load( $this, $whereFields, $whatFields );
        if ($ret==not_found_in_db) {
            return $ret;
        }    
        return $ret;
    }
    function create($overrulePrivilege, &$s)
    {
        return user_create($this, $overrulePrivilege, $s);
    } 
    function changePassword()
    {
        return user_changePassword($this);
    }
    function changeEmail()
    {
        return user_changeEmail($this);
    }
    function valid($where="")
    {
        if( !$where )  
        {
            return ok;
        }
        return user_valid($this, $where);
    }
    function generForm(&$s)
    {
        return user_generForm($this, $s);
    }
    function remindPasswordForm(&$s)
    {
        return user_remindPasswordForm($this, $s);
    }
    function remindPassword()
    {
        return user_remindPassword($this);
    }
    function activateNewPassword(&$s)
    {
        return user_activateNewPassword($this, $s);
    }
    function modify( $whereFields="", $overrulePrivilege=FALSE )
    {
        global $whatHappened;
        $ret = $this->valid("modify");
        if( !$ret && $whatHappened!="invalid_form" )
        {
            $ret = Object::modify($whereFields, $overrulePrivilege);
        }
        return $ret;
    }
    function lowLevelLoginServ(&$s, $needPasswordChange=FALSE)
    {
        return user_lowLevelLoginServ($this, $s, $needPasswordChange);
    }
    function highLevelLoginServ(&$s)
    {
        return user_highLevelLoginServ($this, $s);
    }
    function showListVal($attr)
    {
        global $langTxt,$zorumuser,$zorumrecognised;
        $s="";
        if ($attr=="creationtime" || $attr=="lastVisited" || 
            $attr=="currentVisit" || $attr=="lastClickTime") 
        {    
            if (isset($this->{$attr})) $s=showTimestamp($this->{$attr});
            else $s=$langTxt["never"];
        } 
        else if( $attr=="email" )
        {
            if( $zorumuser->isAdm=="yes" || $this->showEmail=="yes" || 
                ($zorumrecognised && $zorumuser->id==$this->id)) {
                $m=htmlspecialchars($this->{$attr});
                $s="<a href='mailto:$m' class='userLink'>$m</a>";
            }
            else
            {   
                global $langTxt; 
                $s=$langTxt["user_privateEmail"];
            }            
        }   
        else if( $attr=="homepage" && $this->{$attr}!="") {
            if (!eregi("^http:",$this->{$attr})) {
                $t="http:/"."/".$this->{$attr};
            }
            else $t=$this->{$attr};
            $s="<a href='$t' class='userLink'>".$this->{$attr}."</a>";
        }
        else if( $attr=="name" )
        {
            $s=showUserLink($this->{$attr});
        }   
        else if( $attr=="showEmail" ) {
            $s=$langTxt[$this->{$attr}];
        }   
        else if( $attr=="gender" ) {
            $s=$langTxt["gender_".$this->{$attr}];
        }   
        else if( $attr=="notes" || $attr=="signature" ) {
            $s=nl2br(htmlspecialchars($this->{$attr}));
        }
        else if( $attr=="rate" ) {
            if ($this->ratenum==0) $s="<img src='i/b.gif' width='1'".
                                      " height='1'>";
            else {
                $av10=(int)round($this->rateavg*2);
                $alt=sprintf($langTxt["ratealt"],$this->ratenum,
                             $this->rateavg);
                $s="<img src='i/star$av10.gif' width='55' height='10'".
                   " alt='$alt' title='$alt'>";
            }
        }
        else $s=htmlspecialchars($this->{$attr});
        $s=insertSpanClass($s, "listItem");
        return $s;        
    }
    function changeAdmStatus()
    {
        return user_changeAdmStatus($this);
    }
    function loginForm(&$s, $afterInvalidForm=FALSE)
    {
        return user_loginForm($this, $s, $afterInvalidForm);
    }
    function showDetailsMethods()
    {
        return user_showDetailsMethods($this);
    } 
    function showNavBar(&$s)
    {
        return user_showNavBar($this, $s);
    }
    function showNewTool(&$s,$rights)
    {
        global $zorumroll;
        $s="";
        if ($zorumroll->class=="user")
        {
            $ret = showNewTool($this, $s,$rights);
            if ($ret!=ok) {
                return $ret;
            }        
        }    
        return ok;
    }  
}
function getPassword( $s ) 
{ 
    $data = mysql_query("select password('$s')"); 
    $row = mysql_fetch_row($data); 
    return $row[0]; 
} 
?>
